/*
 * Generated by PEG.js 0.10.0.
 *
 * http://pegjs.org/
 */
"use strict";
function peg$subclass(child, parent) {
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor();
}
function peg$SyntaxError(message, expected, found, location) {
    this.message = message;
    this.expected = expected;
    this.found = found;
    this.location = location;
    this.name = "SyntaxError";
    if (typeof Error.captureStackTrace === "function") {
        Error.captureStackTrace(this, peg$SyntaxError);
    }
}
peg$subclass(peg$SyntaxError, Error);
peg$SyntaxError.buildMessage = function (expected, found) {
    var DESCRIBE_EXPECTATION_FNS = {
        literal: function (expectation) {
            return "\"" + literalEscape(expectation.text) + "\"";
        },
        "class": function (expectation) {
            var escapedParts = "", i;
            for (i = 0; i < expectation.parts.length; i++) {
                escapedParts += expectation.parts[i] instanceof Array
                    ? classEscape(expectation.parts[i][0]) + "-" + classEscape(expectation.parts[i][1])
                    : classEscape(expectation.parts[i]);
            }
            return "[" + (expectation.inverted ? "^" : "") + escapedParts + "]";
        },
        any: function (expectation) {
            return "any character";
        },
        end: function (expectation) {
            return "end of input";
        },
        other: function (expectation) {
            return expectation.description;
        }
    };
    function hex(ch) {
        return ch.charCodeAt(0).toString(16).toUpperCase();
    }
    function literalEscape(s) {
        return s
            .replace(/\\/g, '\\\\')
            .replace(/"/g, '\\"')
            .replace(/\0/g, '\\0')
            .replace(/\t/g, '\\t')
            .replace(/\n/g, '\\n')
            .replace(/\r/g, '\\r')
            .replace(/[\x00-\x0F]/g, function (ch) { return '\\x0' + hex(ch); })
            .replace(/[\x10-\x1F\x7F-\x9F]/g, function (ch) { return '\\x' + hex(ch); });
    }
    function classEscape(s) {
        return s
            .replace(/\\/g, '\\\\')
            .replace(/\]/g, '\\]')
            .replace(/\^/g, '\\^')
            .replace(/-/g, '\\-')
            .replace(/\0/g, '\\0')
            .replace(/\t/g, '\\t')
            .replace(/\n/g, '\\n')
            .replace(/\r/g, '\\r')
            .replace(/[\x00-\x0F]/g, function (ch) { return '\\x0' + hex(ch); })
            .replace(/[\x10-\x1F\x7F-\x9F]/g, function (ch) { return '\\x' + hex(ch); });
    }
    function describeExpectation(expectation) {
        return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
    }
    function describeExpected(expected) {
        var descriptions = new Array(expected.length), i, j;
        for (i = 0; i < expected.length; i++) {
            descriptions[i] = describeExpectation(expected[i]);
        }
        descriptions.sort();
        if (descriptions.length > 0) {
            for (i = 1, j = 1; i < descriptions.length; i++) {
                if (descriptions[i - 1] !== descriptions[i]) {
                    descriptions[j] = descriptions[i];
                    j++;
                }
            }
            descriptions.length = j;
        }
        switch (descriptions.length) {
            case 1:
                return descriptions[0];
            case 2:
                return descriptions[0] + " or " + descriptions[1];
            default:
                return descriptions.slice(0, -1).join(", ")
                    + ", or "
                    + descriptions[descriptions.length - 1];
        }
    }
    function describeFound(found) {
        return found ? "\"" + literalEscape(found) + "\"" : "end of input";
    }
    return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
};
function peg$parse(input, options) {
    options = options !== void 0 ? options : {};
    var peg$FAILED = {}, peg$startRuleFunctions = { start: peg$parsestart }, peg$startRuleFunction = peg$parsestart, peg$c0 = function (r) { return filter(flatten(r, true), ';'); }, peg$c1 = function () { return put_if_not_null(stmt, "explain", nonempty(flatstr(explain))); }, peg$c2 = function (x) { return { literal: x }; }, peg$c3 = function (b) { return { bind: b }; }, peg$c4 = function (t) { return { column: t[2], table: t[1] }; }, peg$c5 = function (c) { return { column: c }; }, peg$c6 = function (v) { return v[1]; }, peg$c7 = function (e) { return e[1]; }, peg$c8 = function (digits) {
        var x = flatstr(digits);
        if (x.indexOf('.') >= 0) {
            return parseFloat(x);
        }
        return parseInt(x);
    }, peg$c9 = function (sc) {
        var acc = [];
        for (var i = 0; i < sc.length; i++) {
            acc[i] = merge(sc[i][0], sc[i][1]);
        }
        return acc;
    }, peg$c10 = function () {
        var res = { stmt: "select",
            select_cores: flatten(select_cores, true) };
        res = put_if_not_null(res, "order_by", nonempty(order_by));
        res = put_if_not_null(res, "limit", nonempty(limit));
        return res;
    }, peg$c11 = function (d, cx) {
        var acc = [];
        for (var i = 0; i < cx.length; i++) {
            acc[i] = cx[i][2];
        }
        return acc;
    }, peg$c12 = function (d, c, j) { return j ? j[1] : []; }, peg$c13 = function (d, c, f, e) { return e ? e[1] : []; }, peg$c14 = function () {
        c[1].unshift(c[0]);
        var res = { results: c[1] };
        res = put_if_not_null(res, "distinct", nonempty(flatstr(d)));
        res = put_if_not_null(res, "from", nonempty(f));
        res = put_if_not_null(res, "where", nonempty(w));
        res = put_if_not_null(res, "group_by", nonempty(g));
        return res;
    }, peg$c15 = function (a) { return { alias: a[2] }; }, peg$c16 = function (c) { return merge(c[1], c[0]); }, peg$c17 = function (c) {
        return { table: c[0],
            column: '*' };
    }, peg$c18 = function () { return { column: '*' }; }, peg$c19 = function (r) { return r[1]; }, peg$c20 = function (s) {
        var acc = [s[1]];
        var rest = s[2];
        for (var i = 0; rest != null && i < rest.length; i++) {
            acc[acc.length] = merge(merge(rest[i][0], rest[i][2]), rest[i][3]);
        }
        return acc;
    }, peg$c21 = function (x) { return { database: x[0], table: x[2], alias: x[5] }; }, peg$c22 = function (x) { return { database: x[0], table: x[2] }; }, peg$c23 = function (x) { return { table: x[0], alias: x[3] }; }, peg$c24 = function (x) { return { table: x }; }, peg$c25 = function (t) { return merge(t[1], t[0]); }, peg$c26 = function (idx) { return { indexed_by: idx[3] }; }, peg$c27 = function () { return { indexed_by: null }; }, peg$c28 = function (s) { return merge(s[1], s[0]); }, peg$c29 = function (p) { return merge(p[3], p[1]); }, peg$c30 = function (j) { return j[1]; }, peg$c31 = function () { return "JOIN"; }, peg$c32 = function (j) { return flatstr(j); }, peg$c33 = function (r) { return { join_op: r }; }, peg$c34 = function (r) { return { join_constraint: nonempty(r) }; }, peg$c35 = function (o) { return { compound_operator: flatstr(o) }; }, peg$c36 = function (d) { return { database: d[0] }; }, peg$c37 = function (r) { return merge(r[1], r[0]); }, peg$c38 = function (t) { return { table: t[0] }; }, peg$c39 = function (x) { return { column: x }; }, peg$c40 = /^[^\n]/, peg$c41 = peg$classExpectation(["\n"], true, false), peg$c42 = ".", peg$c43 = peg$literalExpectation(".", false), peg$c44 = ",", peg$c45 = peg$literalExpectation(",", false), peg$c46 = ";", peg$c47 = peg$literalExpectation(";", false), peg$c48 = "--", peg$c49 = peg$literalExpectation("--", false), peg$c50 = "-", peg$c51 = peg$literalExpectation("-", false), peg$c52 = "+", peg$c53 = peg$literalExpectation("+", false), peg$c54 = "(", peg$c55 = peg$literalExpectation("(", false), peg$c56 = ")", peg$c57 = peg$literalExpectation(")", false), peg$c58 = "*", peg$c59 = peg$literalExpectation("*", false), peg$c60 = "\n", peg$c61 = peg$literalExpectation("\n", false), peg$c62 = "/*", peg$c63 = peg$literalExpectation("/*", false), peg$c64 = "*/", peg$c65 = peg$literalExpectation("*/", false), peg$c66 = peg$anyExpectation(), peg$c67 = "\"", peg$c68 = peg$literalExpectation("\"", false), peg$c69 = /^[^"]/, peg$c70 = peg$classExpectation(["\""], true, false), peg$c71 = "\\", peg$c72 = peg$literalExpectation("\\", false), peg$c73 = "", peg$c74 = /^[ \t\n\r]/, peg$c75 = peg$classExpectation([" ", "\t", "\n", "\r"], false, false), peg$c76 = "~", peg$c77 = peg$literalExpectation("~", false), peg$c78 = "NOT", peg$c79 = peg$literalExpectation("NOT", false), peg$c80 = function (x) { return x[1]; }, peg$c81 = "||", peg$c82 = peg$literalExpectation("||", false), peg$c83 = "/", peg$c84 = peg$literalExpectation("/", false), peg$c85 = "%", peg$c86 = peg$literalExpectation("%", false), peg$c87 = "<<", peg$c88 = peg$literalExpectation("<<", false), peg$c89 = ">>", peg$c90 = peg$literalExpectation(">>", false), peg$c91 = "&", peg$c92 = peg$literalExpectation("&", false), peg$c93 = "|", peg$c94 = peg$literalExpectation("|", false), peg$c95 = "<=", peg$c96 = peg$literalExpectation("<=", false), peg$c97 = ">=", peg$c98 = peg$literalExpectation(">=", false), peg$c99 = "<", peg$c100 = peg$literalExpectation("<", false), peg$c101 = ">", peg$c102 = peg$literalExpectation(">", false), peg$c103 = "=", peg$c104 = peg$literalExpectation("=", false), peg$c105 = "==", peg$c106 = peg$literalExpectation("==", false), peg$c107 = "!=", peg$c108 = peg$literalExpectation("!=", false), peg$c109 = "<>", peg$c110 = peg$literalExpectation("<>", false), peg$c111 = "IS", peg$c112 = peg$literalExpectation("IS", false), peg$c113 = "IS NOT", peg$c114 = peg$literalExpectation("IS NOT", false), peg$c115 = "IN", peg$c116 = peg$literalExpectation("IN", false), peg$c117 = "LIKE", peg$c118 = peg$literalExpectation("LIKE", false), peg$c119 = "GLOB", peg$c120 = peg$literalExpectation("GLOB", false), peg$c121 = "MATCH", peg$c122 = peg$literalExpectation("MATCH", false), peg$c123 = "REGEXP", peg$c124 = peg$literalExpectation("REGEXP", false), peg$c125 = "AND", peg$c126 = peg$literalExpectation("AND", false), peg$c127 = "OR", peg$c128 = peg$literalExpectation("OR", false), peg$c129 = /^[0-9]/, peg$c130 = peg$classExpectation([["0", "9"]], false, false), peg$c131 = /^[A-Za-z0-9_]/, peg$c132 = peg$classExpectation([["A", "Z"], ["a", "z"], ["0", "9"], "_"], false, false), peg$c133 = function (str) { return str.join(''); }, peg$c134 = "?", peg$c135 = peg$literalExpectation("?", false), peg$c136 = "now", peg$c137 = peg$literalExpectation("now", false), peg$c138 = "ABORT", peg$c139 = peg$literalExpectation("ABORT", false), peg$c140 = "ACTION", peg$c141 = peg$literalExpectation("ACTION", false), peg$c142 = "ADD", peg$c143 = peg$literalExpectation("ADD", false), peg$c144 = "AFTER", peg$c145 = peg$literalExpectation("AFTER", false), peg$c146 = "ALL", peg$c147 = peg$literalExpectation("ALL", false), peg$c148 = "ALTER", peg$c149 = peg$literalExpectation("ALTER", false), peg$c150 = "ANALYZE", peg$c151 = peg$literalExpectation("ANALYZE", false), peg$c152 = "AS", peg$c153 = peg$literalExpectation("AS", false), peg$c154 = "ASC", peg$c155 = peg$literalExpectation("ASC", false), peg$c156 = "ATTACH", peg$c157 = peg$literalExpectation("ATTACH", false), peg$c158 = "AUTOINCREMENT", peg$c159 = peg$literalExpectation("AUTOINCREMENT", false), peg$c160 = "BEFORE", peg$c161 = peg$literalExpectation("BEFORE", false), peg$c162 = "BEGIN", peg$c163 = peg$literalExpectation("BEGIN", false), peg$c164 = "BETWEEN", peg$c165 = peg$literalExpectation("BETWEEN", false), peg$c166 = "BY", peg$c167 = peg$literalExpectation("BY", false), peg$c168 = "CASCADE", peg$c169 = peg$literalExpectation("CASCADE", false), peg$c170 = "CASE", peg$c171 = peg$literalExpectation("CASE", false), peg$c172 = "CAST", peg$c173 = peg$literalExpectation("CAST", false), peg$c174 = "CHECK", peg$c175 = peg$literalExpectation("CHECK", false), peg$c176 = "COLLATE", peg$c177 = peg$literalExpectation("COLLATE", false), peg$c178 = "COLUMN", peg$c179 = peg$literalExpectation("COLUMN", false), peg$c180 = "COMMIT", peg$c181 = peg$literalExpectation("COMMIT", false), peg$c182 = "CONFLICT", peg$c183 = peg$literalExpectation("CONFLICT", false), peg$c184 = "CONSTRAINT", peg$c185 = peg$literalExpectation("CONSTRAINT", false), peg$c186 = "CREATE", peg$c187 = peg$literalExpectation("CREATE", false), peg$c188 = "CROSS", peg$c189 = peg$literalExpectation("CROSS", false), peg$c190 = "DATABASE", peg$c191 = peg$literalExpectation("DATABASE", false), peg$c192 = "DEFAULT", peg$c193 = peg$literalExpectation("DEFAULT", false), peg$c194 = "DEFERRABLE", peg$c195 = peg$literalExpectation("DEFERRABLE", false), peg$c196 = "DEFERRED", peg$c197 = peg$literalExpectation("DEFERRED", false), peg$c198 = "DELETE", peg$c199 = peg$literalExpectation("DELETE", false), peg$c200 = "DESC", peg$c201 = peg$literalExpectation("DESC", false), peg$c202 = "DETACH", peg$c203 = peg$literalExpectation("DETACH", false), peg$c204 = "DISTINCT", peg$c205 = peg$literalExpectation("DISTINCT", false), peg$c206 = "DROP", peg$c207 = peg$literalExpectation("DROP", false), peg$c208 = "E", peg$c209 = peg$literalExpectation("E", false), peg$c210 = "EACH", peg$c211 = peg$literalExpectation("EACH", false), peg$c212 = "ELSE", peg$c213 = peg$literalExpectation("ELSE", false), peg$c214 = "END", peg$c215 = peg$literalExpectation("END", false), peg$c216 = "ESCAPE", peg$c217 = peg$literalExpectation("ESCAPE", false), peg$c218 = "EXCEPT", peg$c219 = peg$literalExpectation("EXCEPT", false), peg$c220 = "EXCLUSIVE", peg$c221 = peg$literalExpectation("EXCLUSIVE", false), peg$c222 = "EXISTS", peg$c223 = peg$literalExpectation("EXISTS", false), peg$c224 = "EXPLAIN", peg$c225 = peg$literalExpectation("EXPLAIN", false), peg$c226 = "FAIL", peg$c227 = peg$literalExpectation("FAIL", false), peg$c228 = "FOR", peg$c229 = peg$literalExpectation("FOR", false), peg$c230 = "FOREIGN", peg$c231 = peg$literalExpectation("FOREIGN", false), peg$c232 = "FROM", peg$c233 = peg$literalExpectation("FROM", false), peg$c234 = "GROUP", peg$c235 = peg$literalExpectation("GROUP", false), peg$c236 = "HAVING", peg$c237 = peg$literalExpectation("HAVING", false), peg$c238 = "IF", peg$c239 = peg$literalExpectation("IF", false), peg$c240 = "IGNORE", peg$c241 = peg$literalExpectation("IGNORE", false), peg$c242 = "IMMEDIATE", peg$c243 = peg$literalExpectation("IMMEDIATE", false), peg$c244 = "INDEX", peg$c245 = peg$literalExpectation("INDEX", false), peg$c246 = "INDEXED", peg$c247 = peg$literalExpectation("INDEXED", false), peg$c248 = "INITIALLY", peg$c249 = peg$literalExpectation("INITIALLY", false), peg$c250 = "INNER", peg$c251 = peg$literalExpectation("INNER", false), peg$c252 = "INSERT", peg$c253 = peg$literalExpectation("INSERT", false), peg$c254 = "INSTEAD", peg$c255 = peg$literalExpectation("INSTEAD", false), peg$c256 = "INTERSECT", peg$c257 = peg$literalExpectation("INTERSECT", false), peg$c258 = "INTO", peg$c259 = peg$literalExpectation("INTO", false), peg$c260 = "ISNULL", peg$c261 = peg$literalExpectation("ISNULL", false), peg$c262 = "JOIN", peg$c263 = peg$literalExpectation("JOIN", false), peg$c264 = "KEY", peg$c265 = peg$literalExpectation("KEY", false), peg$c266 = "LEFT", peg$c267 = peg$literalExpectation("LEFT", false), peg$c268 = "LIMIT", peg$c269 = peg$literalExpectation("LIMIT", false), peg$c270 = "NATURAL", peg$c271 = peg$literalExpectation("NATURAL", false), peg$c272 = "NO", peg$c273 = peg$literalExpectation("NO", false), peg$c274 = "NOTNULL", peg$c275 = peg$literalExpectation("NOTNULL", false), peg$c276 = "NULL", peg$c277 = peg$literalExpectation("NULL", false), peg$c278 = "OF", peg$c279 = peg$literalExpectation("OF", false), peg$c280 = "OFFSET", peg$c281 = peg$literalExpectation("OFFSET", false), peg$c282 = "ON", peg$c283 = peg$literalExpectation("ON", false), peg$c284 = "ORDER", peg$c285 = peg$literalExpectation("ORDER", false), peg$c286 = "OUTER", peg$c287 = peg$literalExpectation("OUTER", false), peg$c288 = "PLAN", peg$c289 = peg$literalExpectation("PLAN", false), peg$c290 = "PRAGMA", peg$c291 = peg$literalExpectation("PRAGMA", false), peg$c292 = "PRIMARY", peg$c293 = peg$literalExpectation("PRIMARY", false), peg$c294 = "QUERY", peg$c295 = peg$literalExpectation("QUERY", false), peg$c296 = "RAISE", peg$c297 = peg$literalExpectation("RAISE", false), peg$c298 = "REFERENCES", peg$c299 = peg$literalExpectation("REFERENCES", false), peg$c300 = "REINDEX", peg$c301 = peg$literalExpectation("REINDEX", false), peg$c302 = "RELEASE", peg$c303 = peg$literalExpectation("RELEASE", false), peg$c304 = "RENAME", peg$c305 = peg$literalExpectation("RENAME", false), peg$c306 = "REPLACE", peg$c307 = peg$literalExpectation("REPLACE", false), peg$c308 = "RESTRICT", peg$c309 = peg$literalExpectation("RESTRICT", false), peg$c310 = "ROLLBACK", peg$c311 = peg$literalExpectation("ROLLBACK", false), peg$c312 = "ROW", peg$c313 = peg$literalExpectation("ROW", false), peg$c314 = "SAVEPOINT", peg$c315 = peg$literalExpectation("SAVEPOINT", false), peg$c316 = "SELECT", peg$c317 = peg$literalExpectation("SELECT", false), peg$c318 = "SET", peg$c319 = peg$literalExpectation("SET", false), peg$c320 = "TABLE", peg$c321 = peg$literalExpectation("TABLE", false), peg$c322 = "TEMP", peg$c323 = peg$literalExpectation("TEMP", false), peg$c324 = "TEMPORARY", peg$c325 = peg$literalExpectation("TEMPORARY", false), peg$c326 = "THEN", peg$c327 = peg$literalExpectation("THEN", false), peg$c328 = "TO", peg$c329 = peg$literalExpectation("TO", false), peg$c330 = "TRANSACTION", peg$c331 = peg$literalExpectation("TRANSACTION", false), peg$c332 = "TRIGGER", peg$c333 = peg$literalExpectation("TRIGGER", false), peg$c334 = "UNION", peg$c335 = peg$literalExpectation("UNION", false), peg$c336 = "UNIQUE", peg$c337 = peg$literalExpectation("UNIQUE", false), peg$c338 = "UPDATE", peg$c339 = peg$literalExpectation("UPDATE", false), peg$c340 = "USING", peg$c341 = peg$literalExpectation("USING", false), peg$c342 = "VACUUM", peg$c343 = peg$literalExpectation("VACUUM", false), peg$c344 = "VALUES", peg$c345 = peg$literalExpectation("VALUES", false), peg$c346 = "VIEW", peg$c347 = peg$literalExpectation("VIEW", false), peg$c348 = "VIRTUAL", peg$c349 = peg$literalExpectation("VIRTUAL", false), peg$c350 = "WHEN", peg$c351 = peg$literalExpectation("WHEN", false), peg$c352 = "WHERE", peg$c353 = peg$literalExpectation("WHERE", false), peg$currPos = 0, peg$savedPos = 0, peg$posDetailsCache = [{ line: 1, column: 1 }], peg$maxFailPos = 0, peg$maxFailExpected = [], peg$silentFails = 0, peg$result;
    if ("startRule" in options) {
        if (!(options.startRule in peg$startRuleFunctions)) {
            throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
        }
        peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
    }
    function text() {
        return input.substring(peg$savedPos, peg$currPos);
    }
    function location() {
        return peg$computeLocation(peg$savedPos, peg$currPos);
    }
    function expected(description, location) {
        location = location !== void 0 ? location : peg$computeLocation(peg$savedPos, peg$currPos);
        throw peg$buildStructuredError([peg$otherExpectation(description)], input.substring(peg$savedPos, peg$currPos), location);
    }
    function error(message, location) {
        location = location !== void 0 ? location : peg$computeLocation(peg$savedPos, peg$currPos);
        throw peg$buildSimpleError(message, location);
    }
    function peg$literalExpectation(text, ignoreCase) {
        return { type: "literal", text: text, ignoreCase: ignoreCase };
    }
    function peg$classExpectation(parts, inverted, ignoreCase) {
        return { type: "class", parts: parts, inverted: inverted, ignoreCase: ignoreCase };
    }
    function peg$anyExpectation() {
        return { type: "any" };
    }
    function peg$endExpectation() {
        return { type: "end" };
    }
    function peg$otherExpectation(description) {
        return { type: "other", description: description };
    }
    function peg$computePosDetails(pos) {
        var details = peg$posDetailsCache[pos], p;
        if (details) {
            return details;
        }
        else {
            p = pos - 1;
            while (!peg$posDetailsCache[p]) {
                p--;
            }
            details = peg$posDetailsCache[p];
            details = {
                line: details.line,
                column: details.column
            };
            while (p < pos) {
                if (input.charCodeAt(p) === 10) {
                    details.line++;
                    details.column = 1;
                }
                else {
                    details.column++;
                }
                p++;
            }
            peg$posDetailsCache[pos] = details;
            return details;
        }
    }
    function peg$computeLocation(startPos, endPos) {
        var startPosDetails = peg$computePosDetails(startPos), endPosDetails = peg$computePosDetails(endPos);
        return {
            start: {
                offset: startPos,
                line: startPosDetails.line,
                column: startPosDetails.column
            },
            end: {
                offset: endPos,
                line: endPosDetails.line,
                column: endPosDetails.column
            }
        };
    }
    function peg$fail(expected) {
        if (peg$currPos < peg$maxFailPos) {
            return;
        }
        if (peg$currPos > peg$maxFailPos) {
            peg$maxFailPos = peg$currPos;
            peg$maxFailExpected = [];
        }
        peg$maxFailExpected.push(expected);
    }
    function peg$buildSimpleError(message, location) {
        return new peg$SyntaxError(message, null, null, location);
    }
    function peg$buildStructuredError(expected, found, location) {
        return new peg$SyntaxError(peg$SyntaxError.buildMessage(expected, found), expected, found, location);
    }
    function peg$parsestart() {
        var s0;
        s0 = peg$parsesql_stmt_list();
        return s0;
    }
    function peg$parsesql_stmt_list() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$currPos;
        s3 = peg$parsewhitespace();
        if (s3 !== peg$FAILED) {
            s4 = peg$parsesql_stmt();
            if (s4 === peg$FAILED) {
                s4 = null;
            }
            if (s4 !== peg$FAILED) {
                s5 = peg$parsewhitespace();
                if (s5 !== peg$FAILED) {
                    s6 = peg$parsesemicolon();
                    if (s6 !== peg$FAILED) {
                        s3 = [s3, s4, s5, s6];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s2;
            s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$currPos;
                s3 = peg$parsewhitespace();
                if (s3 !== peg$FAILED) {
                    s4 = peg$parsesql_stmt();
                    if (s4 === peg$FAILED) {
                        s4 = null;
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parsewhitespace();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parsesemicolon();
                            if (s6 !== peg$FAILED) {
                                s3 = [s3, s4, s5, s6];
                                s2 = s3;
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
        }
        else {
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c0(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsesql_stmt() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$currPos;
        s3 = peg$parseEXPLAIN();
        if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            s5 = peg$parseQUERY();
            if (s5 !== peg$FAILED) {
                s6 = peg$parsePLAN();
                if (s6 !== peg$FAILED) {
                    s5 = [s5, s6];
                    s4 = s5;
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s4;
                s4 = peg$FAILED;
            }
            if (s4 === peg$FAILED) {
                s4 = null;
            }
            if (s4 !== peg$FAILED) {
                s3 = [s3, s4];
                s2 = s3;
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s2;
            s2 = peg$FAILED;
        }
        if (s2 === peg$FAILED) {
            s2 = null;
        }
        if (s2 !== peg$FAILED) {
            s3 = peg$parseselect_stmt();
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c1();
        }
        s0 = s1;
        return s0;
    }
    function peg$parsealter_table_stmt() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseALTER();
        if (s2 !== peg$FAILED) {
            s3 = peg$parseTABLE();
            if (s3 !== peg$FAILED) {
                s4 = peg$parsetable_ref();
                if (s4 !== peg$FAILED) {
                    s2 = [s2, s3, s4];
                    s1 = s2;
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parseRENAME();
            if (s3 !== peg$FAILED) {
                s4 = peg$parseTO();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parsename();
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parseADD();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseCOLUMN();
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsecolumn_def();
                        if (s6 !== peg$FAILED) {
                            s4 = [s4, s5, s6];
                            s3 = s4;
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseanalyze_stmt() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseANALYZE();
        if (s1 !== peg$FAILED) {
            s2 = peg$parsename();
            if (s2 === peg$FAILED) {
                s2 = peg$parsename();
                if (s2 === peg$FAILED) {
                    s2 = peg$currPos;
                    s3 = peg$parsename();
                    if (s3 !== peg$FAILED) {
                        s4 = peg$parsedot();
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parsename();
                            if (s5 !== peg$FAILED) {
                                s3 = [s3, s4, s5];
                                s2 = s3;
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
            }
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseattach_stmt() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseATTACH();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseDATABASE();
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseexpr();
                if (s3 !== peg$FAILED) {
                    s4 = peg$parseAS();
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parsename();
                        if (s5 !== peg$FAILED) {
                            s1 = [s1, s2, s3, s4, s5];
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsebegin_stmt() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseBEGIN();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseDEFERRED();
            if (s2 === peg$FAILED) {
                s2 = peg$parseIMMEDIATE();
                if (s2 === peg$FAILED) {
                    s2 = peg$parseEXCLUSIVE();
                }
            }
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseTRANSACTION();
                if (s3 === peg$FAILED) {
                    s3 = null;
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsecommit_stmt() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parseCOMMIT();
        if (s1 === peg$FAILED) {
            s1 = peg$parseEND();
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$parseTRANSACTION();
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parserollback_stmt() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parseROLLBACK();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseTRANSACTION();
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parseTO();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseSAVEPOINT();
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsename();
                        if (s6 !== peg$FAILED) {
                            s4 = [s4, s5, s6];
                            s3 = s4;
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                    s3 = null;
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsesavepoint_stmt() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parseSAVEPOINT();
        if (s1 !== peg$FAILED) {
            s2 = peg$parsename();
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parserelease_stmt() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseRELEASE();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseSAVEPOINT();
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parsename();
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsecreate_index_stmt() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseCREATE();
        if (s2 !== peg$FAILED) {
            s3 = peg$parseUNIQUE();
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parseINDEX();
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$parseIF();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parseNOT();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseEXISTS();
                            if (s8 !== peg$FAILED) {
                                s6 = [s6, s7, s8];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s2 = [s2, s3, s4, s5];
                        s1 = s2;
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$currPos;
            s4 = peg$parsename();
            if (s4 !== peg$FAILED) {
                s5 = peg$parsedot();
                if (s5 !== peg$FAILED) {
                    s4 = [s4, s5];
                    s3 = s4;
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parsename();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseON();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsename();
                        if (s6 !== peg$FAILED) {
                            s7 = peg$parselparen();
                            if (s7 !== peg$FAILED) {
                                s8 = [];
                                s9 = peg$currPos;
                                s10 = peg$parseindexed_column();
                                if (s10 !== peg$FAILED) {
                                    s11 = peg$parsecomma();
                                    if (s11 !== peg$FAILED) {
                                        s10 = [s10, s11];
                                        s9 = s10;
                                    }
                                    else {
                                        peg$currPos = s9;
                                        s9 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s9;
                                    s9 = peg$FAILED;
                                }
                                if (s9 !== peg$FAILED) {
                                    while (s9 !== peg$FAILED) {
                                        s8.push(s9);
                                        s9 = peg$currPos;
                                        s10 = peg$parseindexed_column();
                                        if (s10 !== peg$FAILED) {
                                            s11 = peg$parsecomma();
                                            if (s11 !== peg$FAILED) {
                                                s10 = [s10, s11];
                                                s9 = s10;
                                            }
                                            else {
                                                peg$currPos = s9;
                                                s9 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s9;
                                            s9 = peg$FAILED;
                                        }
                                    }
                                }
                                else {
                                    s8 = peg$FAILED;
                                }
                                if (s8 !== peg$FAILED) {
                                    s9 = peg$parserparen();
                                    if (s9 !== peg$FAILED) {
                                        s3 = [s3, s4, s5, s6, s7, s8, s9];
                                        s2 = s3;
                                    }
                                    else {
                                        peg$currPos = s2;
                                        s2 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s2;
                                    s2 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseindexed_column() {
        var s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = peg$parsename();
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parseCOLLATE();
            if (s3 !== peg$FAILED) {
                s4 = peg$parsename();
                if (s4 !== peg$FAILED) {
                    s3 = [s3, s4];
                    s2 = s3;
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parseASC();
                if (s3 === peg$FAILED) {
                    s3 = peg$parseDESC();
                }
                if (s3 === peg$FAILED) {
                    s3 = null;
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsecreate_table_stmt() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseCREATE();
        if (s2 !== peg$FAILED) {
            s3 = peg$parseTEMP();
            if (s3 === peg$FAILED) {
                s3 = peg$parseTEMPORARY();
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parseTABLE();
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$parseIF();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parseNOT();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseEXISTS();
                            if (s8 !== peg$FAILED) {
                                s6 = [s6, s7, s8];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s2 = [s2, s3, s4, s5];
                        s1 = s2;
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parsetable_ref();
            if (s3 !== peg$FAILED) {
                s4 = peg$currPos;
                s5 = peg$parselparen();
                if (s5 !== peg$FAILED) {
                    s6 = [];
                    s7 = peg$currPos;
                    s8 = peg$parsecolumn_def();
                    if (s8 !== peg$FAILED) {
                        s9 = peg$parsecomma();
                        if (s9 !== peg$FAILED) {
                            s8 = [s8, s9];
                            s7 = s8;
                        }
                        else {
                            peg$currPos = s7;
                            s7 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s7;
                        s7 = peg$FAILED;
                    }
                    if (s7 !== peg$FAILED) {
                        while (s7 !== peg$FAILED) {
                            s6.push(s7);
                            s7 = peg$currPos;
                            s8 = peg$parsecolumn_def();
                            if (s8 !== peg$FAILED) {
                                s9 = peg$parsecomma();
                                if (s9 !== peg$FAILED) {
                                    s8 = [s8, s9];
                                    s7 = s8;
                                }
                                else {
                                    peg$currPos = s7;
                                    s7 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s7;
                                s7 = peg$FAILED;
                            }
                        }
                    }
                    else {
                        s6 = peg$FAILED;
                    }
                    if (s6 !== peg$FAILED) {
                        s7 = [];
                        s8 = peg$currPos;
                        s9 = peg$parsecomma();
                        if (s9 !== peg$FAILED) {
                            s10 = peg$parsetable_constraint();
                            if (s10 !== peg$FAILED) {
                                s9 = [s9, s10];
                                s8 = s9;
                            }
                            else {
                                peg$currPos = s8;
                                s8 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s8;
                            s8 = peg$FAILED;
                        }
                        if (s8 !== peg$FAILED) {
                            while (s8 !== peg$FAILED) {
                                s7.push(s8);
                                s8 = peg$currPos;
                                s9 = peg$parsecomma();
                                if (s9 !== peg$FAILED) {
                                    s10 = peg$parsetable_constraint();
                                    if (s10 !== peg$FAILED) {
                                        s9 = [s9, s10];
                                        s8 = s9;
                                    }
                                    else {
                                        peg$currPos = s8;
                                        s8 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s8;
                                    s8 = peg$FAILED;
                                }
                            }
                        }
                        else {
                            s7 = peg$FAILED;
                        }
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parserparen();
                            if (s8 !== peg$FAILED) {
                                s5 = [s5, s6, s7, s8];
                                s4 = s5;
                            }
                            else {
                                peg$currPos = s4;
                                s4 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$parseAS();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parseselect_stmt();
                        if (s7 !== peg$FAILED) {
                            s6 = [s6, s7];
                            s5 = s6;
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsecolumn_def() {
        var s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = peg$parsename();
        if (s1 !== peg$FAILED) {
            s2 = peg$parsetype_name();
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s3 = [];
                s4 = peg$parsecolumn_constraint();
                if (s4 !== peg$FAILED) {
                    while (s4 !== peg$FAILED) {
                        s3.push(s4);
                        s4 = peg$parsecolumn_constraint();
                    }
                }
                else {
                    s3 = peg$FAILED;
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsetype_name() {
        var s0, s1, s2, s3, s4, s5, s6, s7;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parsename();
        if (s2 !== peg$FAILED) {
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                s2 = peg$parsename();
            }
        }
        else {
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parselparen();
            if (s3 !== peg$FAILED) {
                s4 = peg$parsesigned_number();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parserparen();
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 === peg$FAILED) {
                s2 = peg$currPos;
                s3 = peg$parselparen();
                if (s3 !== peg$FAILED) {
                    s4 = peg$parsesigned_number();
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parsecomma();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parsesigned_number();
                            if (s6 !== peg$FAILED) {
                                s7 = peg$parserparen();
                                if (s7 !== peg$FAILED) {
                                    s3 = [s3, s4, s5, s6, s7];
                                    s2 = s3;
                                }
                                else {
                                    peg$currPos = s2;
                                    s2 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsecolumn_constraint() {
        var s0, s1, s2, s3, s4, s5, s6, s7;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseCONSTRAINT();
        if (s2 !== peg$FAILED) {
            s3 = peg$parsename();
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 === peg$FAILED) {
            s1 = null;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parsePRIMARY();
            if (s3 !== peg$FAILED) {
                s4 = peg$parseKEY();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseASC();
                    if (s5 === peg$FAILED) {
                        s5 = peg$parseDESC();
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parseconflict_clause();
                        if (s6 !== peg$FAILED) {
                            s7 = peg$parseAUTOINCREMENT();
                            if (s7 === peg$FAILED) {
                                s7 = null;
                            }
                            if (s7 !== peg$FAILED) {
                                s3 = [s3, s4, s5, s6, s7];
                                s2 = s3;
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 === peg$FAILED) {
                s2 = peg$currPos;
                s3 = peg$parseNOT();
                if (s3 !== peg$FAILED) {
                    s4 = peg$parseNULL();
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseconflict_clause();
                        if (s5 !== peg$FAILED) {
                            s3 = [s3, s4, s5];
                            s2 = s3;
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
                if (s2 === peg$FAILED) {
                    s2 = peg$currPos;
                    s3 = peg$parseUNIQUE();
                    if (s3 !== peg$FAILED) {
                        s4 = peg$parseconflict_clause();
                        if (s4 !== peg$FAILED) {
                            s3 = [s3, s4];
                            s2 = s3;
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                    if (s2 === peg$FAILED) {
                        s2 = peg$currPos;
                        s3 = peg$parseCHECK();
                        if (s3 !== peg$FAILED) {
                            s4 = peg$parselparen();
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parseexpr();
                                if (s5 !== peg$FAILED) {
                                    s6 = peg$parserparen();
                                    if (s6 !== peg$FAILED) {
                                        s3 = [s3, s4, s5, s6];
                                        s2 = s3;
                                    }
                                    else {
                                        peg$currPos = s2;
                                        s2 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s2;
                                    s2 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                        if (s2 === peg$FAILED) {
                            s2 = peg$currPos;
                            s3 = peg$parseDEFAULT();
                            if (s3 !== peg$FAILED) {
                                s4 = peg$parsesigned_number();
                                if (s4 === peg$FAILED) {
                                    s4 = peg$parseliteral_value();
                                    if (s4 === peg$FAILED) {
                                        s4 = peg$currPos;
                                        s5 = peg$parselparen();
                                        if (s5 !== peg$FAILED) {
                                            s6 = peg$parseexpr();
                                            if (s6 !== peg$FAILED) {
                                                s7 = peg$parserparen();
                                                if (s7 !== peg$FAILED) {
                                                    s5 = [s5, s6, s7];
                                                    s4 = s5;
                                                }
                                                else {
                                                    peg$currPos = s4;
                                                    s4 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s4;
                                                s4 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s4;
                                            s4 = peg$FAILED;
                                        }
                                    }
                                }
                                if (s4 !== peg$FAILED) {
                                    s3 = [s3, s4];
                                    s2 = s3;
                                }
                                else {
                                    peg$currPos = s2;
                                    s2 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                            if (s2 === peg$FAILED) {
                                s2 = peg$currPos;
                                s3 = peg$parseCOLLATE();
                                if (s3 !== peg$FAILED) {
                                    s4 = peg$parsename();
                                    if (s4 !== peg$FAILED) {
                                        s3 = [s3, s4];
                                        s2 = s3;
                                    }
                                    else {
                                        peg$currPos = s2;
                                        s2 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s2;
                                    s2 = peg$FAILED;
                                }
                                if (s2 === peg$FAILED) {
                                    s2 = peg$parseforeign_key_clause();
                                }
                            }
                        }
                    }
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsesigned_number() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parseplus();
        if (s1 === peg$FAILED) {
            s1 = peg$parseminus();
        }
        if (s1 === peg$FAILED) {
            s1 = null;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$parsenumeric_literal();
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsetable_constraint() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseCONSTRAINT();
        if (s2 !== peg$FAILED) {
            s3 = peg$parsename();
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 === peg$FAILED) {
            s1 = null;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$currPos;
            s4 = peg$parsePRIMARY();
            if (s4 !== peg$FAILED) {
                s5 = peg$parseKEY();
                if (s5 !== peg$FAILED) {
                    s4 = [s4, s5];
                    s3 = s4;
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = peg$parseUNIQUE();
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parselparen();
                if (s4 !== peg$FAILED) {
                    s5 = [];
                    s6 = peg$currPos;
                    s7 = peg$parseindexed_column();
                    if (s7 !== peg$FAILED) {
                        s8 = peg$parsecomma();
                        if (s8 !== peg$FAILED) {
                            s7 = [s7, s8];
                            s6 = s7;
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s6;
                        s6 = peg$FAILED;
                    }
                    if (s6 !== peg$FAILED) {
                        while (s6 !== peg$FAILED) {
                            s5.push(s6);
                            s6 = peg$currPos;
                            s7 = peg$parseindexed_column();
                            if (s7 !== peg$FAILED) {
                                s8 = peg$parsecomma();
                                if (s8 !== peg$FAILED) {
                                    s7 = [s7, s8];
                                    s6 = s7;
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                        }
                    }
                    else {
                        s5 = peg$FAILED;
                    }
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parserparen();
                        if (s6 !== peg$FAILED) {
                            s7 = peg$parseconflict_clause();
                            if (s7 !== peg$FAILED) {
                                s3 = [s3, s4, s5, s6, s7];
                                s2 = s3;
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 === peg$FAILED) {
                s2 = peg$currPos;
                s3 = peg$parseCHECK();
                if (s3 !== peg$FAILED) {
                    s4 = peg$parselparen();
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseexpr();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parserparen();
                            if (s6 !== peg$FAILED) {
                                s3 = [s3, s4, s5, s6];
                                s2 = s3;
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
                if (s2 === peg$FAILED) {
                    s2 = peg$currPos;
                    s3 = peg$parseFOREIGN();
                    if (s3 !== peg$FAILED) {
                        s4 = peg$parseKEY();
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parselparen();
                            if (s5 !== peg$FAILED) {
                                s6 = [];
                                s7 = peg$currPos;
                                s8 = peg$parsename();
                                if (s8 !== peg$FAILED) {
                                    s9 = peg$parsecomma();
                                    if (s9 !== peg$FAILED) {
                                        s8 = [s8, s9];
                                        s7 = s8;
                                    }
                                    else {
                                        peg$currPos = s7;
                                        s7 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s7;
                                    s7 = peg$FAILED;
                                }
                                if (s7 !== peg$FAILED) {
                                    while (s7 !== peg$FAILED) {
                                        s6.push(s7);
                                        s7 = peg$currPos;
                                        s8 = peg$parsename();
                                        if (s8 !== peg$FAILED) {
                                            s9 = peg$parsecomma();
                                            if (s9 !== peg$FAILED) {
                                                s8 = [s8, s9];
                                                s7 = s8;
                                            }
                                            else {
                                                peg$currPos = s7;
                                                s7 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s7;
                                            s7 = peg$FAILED;
                                        }
                                    }
                                }
                                else {
                                    s6 = peg$FAILED;
                                }
                                if (s6 !== peg$FAILED) {
                                    s7 = peg$parserparen();
                                    if (s7 !== peg$FAILED) {
                                        s8 = peg$parseforeign_key_clause();
                                        if (s8 !== peg$FAILED) {
                                            s3 = [s3, s4, s5, s6, s7, s8];
                                            s2 = s3;
                                        }
                                        else {
                                            peg$currPos = s2;
                                            s2 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s2;
                                        s2 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s2;
                                    s2 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s2;
                                s2 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseforeign_key_clause() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseREFERENCES();
        if (s2 !== peg$FAILED) {
            s3 = peg$parsename();
            if (s3 !== peg$FAILED) {
                s4 = peg$currPos;
                s5 = peg$parselparen();
                if (s5 !== peg$FAILED) {
                    s6 = [];
                    s7 = peg$currPos;
                    s8 = peg$parsename();
                    if (s8 !== peg$FAILED) {
                        s9 = peg$parsecomma();
                        if (s9 !== peg$FAILED) {
                            s8 = [s8, s9];
                            s7 = s8;
                        }
                        else {
                            peg$currPos = s7;
                            s7 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s7;
                        s7 = peg$FAILED;
                    }
                    if (s7 !== peg$FAILED) {
                        while (s7 !== peg$FAILED) {
                            s6.push(s7);
                            s7 = peg$currPos;
                            s8 = peg$parsename();
                            if (s8 !== peg$FAILED) {
                                s9 = peg$parsecomma();
                                if (s9 !== peg$FAILED) {
                                    s8 = [s8, s9];
                                    s7 = s8;
                                }
                                else {
                                    peg$currPos = s7;
                                    s7 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s7;
                                s7 = peg$FAILED;
                            }
                        }
                    }
                    else {
                        s6 = peg$FAILED;
                    }
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parserparen();
                        if (s7 !== peg$FAILED) {
                            s5 = [s5, s6, s7];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
                if (s4 === peg$FAILED) {
                    s4 = null;
                }
                if (s4 !== peg$FAILED) {
                    s2 = [s2, s3, s4];
                    s1 = s2;
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$currPos;
            s4 = peg$parseON();
            if (s4 !== peg$FAILED) {
                s5 = peg$parseDELETE();
                if (s5 === peg$FAILED) {
                    s5 = peg$parseUPDATE();
                }
                if (s5 !== peg$FAILED) {
                    s6 = peg$currPos;
                    s7 = peg$parseSET();
                    if (s7 !== peg$FAILED) {
                        s8 = peg$parseNULL();
                        if (s8 !== peg$FAILED) {
                            s7 = [s7, s8];
                            s6 = s7;
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s6;
                        s6 = peg$FAILED;
                    }
                    if (s6 === peg$FAILED) {
                        s6 = peg$currPos;
                        s7 = peg$parseSET();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseDEFAULT();
                            if (s8 !== peg$FAILED) {
                                s7 = [s7, s8];
                                s6 = s7;
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                        if (s6 === peg$FAILED) {
                            s6 = peg$parseCASCADE();
                            if (s6 === peg$FAILED) {
                                s6 = peg$parseRESTRICT();
                                if (s6 === peg$FAILED) {
                                    s6 = peg$currPos;
                                    s7 = peg$parseNO();
                                    if (s7 !== peg$FAILED) {
                                        s8 = peg$parseACTION();
                                        if (s8 !== peg$FAILED) {
                                            s7 = [s7, s8];
                                            s6 = s7;
                                        }
                                        else {
                                            peg$currPos = s6;
                                            s6 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s6;
                                        s6 = peg$FAILED;
                                    }
                                }
                            }
                        }
                    }
                    if (s6 !== peg$FAILED) {
                        s4 = [s4, s5, s6];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parseMATCH();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parsename();
                    if (s5 !== peg$FAILED) {
                        s4 = [s4, s5];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            if (s3 !== peg$FAILED) {
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$currPos;
                    s4 = peg$parseON();
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseDELETE();
                        if (s5 === peg$FAILED) {
                            s5 = peg$parseUPDATE();
                        }
                        if (s5 !== peg$FAILED) {
                            s6 = peg$currPos;
                            s7 = peg$parseSET();
                            if (s7 !== peg$FAILED) {
                                s8 = peg$parseNULL();
                                if (s8 !== peg$FAILED) {
                                    s7 = [s7, s8];
                                    s6 = s7;
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                            if (s6 === peg$FAILED) {
                                s6 = peg$currPos;
                                s7 = peg$parseSET();
                                if (s7 !== peg$FAILED) {
                                    s8 = peg$parseDEFAULT();
                                    if (s8 !== peg$FAILED) {
                                        s7 = [s7, s8];
                                        s6 = s7;
                                    }
                                    else {
                                        peg$currPos = s6;
                                        s6 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                                if (s6 === peg$FAILED) {
                                    s6 = peg$parseCASCADE();
                                    if (s6 === peg$FAILED) {
                                        s6 = peg$parseRESTRICT();
                                        if (s6 === peg$FAILED) {
                                            s6 = peg$currPos;
                                            s7 = peg$parseNO();
                                            if (s7 !== peg$FAILED) {
                                                s8 = peg$parseACTION();
                                                if (s8 !== peg$FAILED) {
                                                    s7 = [s7, s8];
                                                    s6 = s7;
                                                }
                                                else {
                                                    peg$currPos = s6;
                                                    s6 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s6;
                                                s6 = peg$FAILED;
                                            }
                                        }
                                    }
                                }
                            }
                            if (s6 !== peg$FAILED) {
                                s4 = [s4, s5, s6];
                                s3 = s4;
                            }
                            else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                    if (s3 === peg$FAILED) {
                        s3 = peg$currPos;
                        s4 = peg$parseMATCH();
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parsename();
                            if (s5 !== peg$FAILED) {
                                s4 = [s4, s5];
                                s3 = s4;
                            }
                            else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                }
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parseNOT();
                if (s4 === peg$FAILED) {
                    s4 = null;
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseDEFERRABLE();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$currPos;
                        s7 = peg$parseINITIALLY();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseDEFERRED();
                            if (s8 !== peg$FAILED) {
                                s7 = [s7, s8];
                                s6 = s7;
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                        if (s6 === peg$FAILED) {
                            s6 = peg$currPos;
                            s7 = peg$parseINITIALLY();
                            if (s7 !== peg$FAILED) {
                                s8 = peg$parseIMMEDIATE();
                                if (s8 !== peg$FAILED) {
                                    s7 = [s7, s8];
                                    s6 = s7;
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                        }
                        if (s6 === peg$FAILED) {
                            s6 = null;
                        }
                        if (s6 !== peg$FAILED) {
                            s4 = [s4, s5, s6];
                            s3 = s4;
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                    s3 = null;
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseconflict_clause() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseON();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseCONFLICT();
            if (s2 !== peg$FAILED) {
                s3 = peg$parseROLLBACK();
                if (s3 === peg$FAILED) {
                    s3 = peg$parseABORT();
                    if (s3 === peg$FAILED) {
                        s3 = peg$parseFAIL();
                        if (s3 === peg$FAILED) {
                            s3 = peg$parseIGNORE();
                            if (s3 === peg$FAILED) {
                                s3 = peg$parseREPLACE();
                            }
                        }
                    }
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = null;
        }
        return s0;
    }
    function peg$parsecreate_trigger_stmt() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseCREATE();
        if (s2 !== peg$FAILED) {
            s3 = peg$parseTEMP();
            if (s3 === peg$FAILED) {
                s3 = peg$parseTEMPORARY();
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parseTRIGGER();
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$parseIF();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parseNOT();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseEXISTS();
                            if (s8 !== peg$FAILED) {
                                s6 = [s6, s7, s8];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s2 = [s2, s3, s4, s5];
                        s1 = s2;
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$currPos;
            s4 = peg$parsename();
            if (s4 !== peg$FAILED) {
                s5 = peg$parsedot();
                if (s5 !== peg$FAILED) {
                    s4 = [s4, s5];
                    s3 = s4;
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parsename();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseBEFORE();
                    if (s5 === peg$FAILED) {
                        s5 = peg$parseAFTER();
                        if (s5 === peg$FAILED) {
                            s5 = peg$currPos;
                            s6 = peg$parseINSTEAD();
                            if (s6 !== peg$FAILED) {
                                s7 = peg$parseOF();
                                if (s7 !== peg$FAILED) {
                                    s6 = [s6, s7];
                                    s5 = s6;
                                }
                                else {
                                    peg$currPos = s5;
                                    s5 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parseDELETE();
                if (s4 === peg$FAILED) {
                    s4 = peg$parseINSERT();
                    if (s4 === peg$FAILED) {
                        s4 = peg$currPos;
                        s5 = peg$parseUPDATE();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$currPos;
                            s7 = peg$parseOF();
                            if (s7 !== peg$FAILED) {
                                s8 = [];
                                s9 = peg$currPos;
                                s10 = peg$parsename();
                                if (s10 !== peg$FAILED) {
                                    s11 = peg$parsecomma();
                                    if (s11 !== peg$FAILED) {
                                        s10 = [s10, s11];
                                        s9 = s10;
                                    }
                                    else {
                                        peg$currPos = s9;
                                        s9 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s9;
                                    s9 = peg$FAILED;
                                }
                                if (s9 !== peg$FAILED) {
                                    while (s9 !== peg$FAILED) {
                                        s8.push(s9);
                                        s9 = peg$currPos;
                                        s10 = peg$parsename();
                                        if (s10 !== peg$FAILED) {
                                            s11 = peg$parsecomma();
                                            if (s11 !== peg$FAILED) {
                                                s10 = [s10, s11];
                                                s9 = s10;
                                            }
                                            else {
                                                peg$currPos = s9;
                                                s9 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s9;
                                            s9 = peg$FAILED;
                                        }
                                    }
                                }
                                else {
                                    s8 = peg$FAILED;
                                }
                                if (s8 !== peg$FAILED) {
                                    s7 = [s7, s8];
                                    s6 = s7;
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                            if (s6 === peg$FAILED) {
                                s6 = null;
                            }
                            if (s6 !== peg$FAILED) {
                                s5 = [s5, s6];
                                s4 = s5;
                            }
                            else {
                                peg$currPos = s4;
                                s4 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseON();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsename();
                        if (s6 !== peg$FAILED) {
                            s4 = [s4, s5, s6];
                            s3 = s4;
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    s5 = peg$currPos;
                    s6 = peg$parseFOR();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parseEACH();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseROW();
                            if (s8 !== peg$FAILED) {
                                s6 = [s6, s7, s8];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s6 = peg$currPos;
                        s7 = peg$parseWHEN();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseexpr();
                            if (s8 !== peg$FAILED) {
                                s7 = [s7, s8];
                                s6 = s7;
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                        if (s6 === peg$FAILED) {
                            s6 = null;
                        }
                        if (s6 !== peg$FAILED) {
                            s5 = [s5, s6];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$currPos;
                        s6 = peg$parseBEGIN();
                        if (s6 !== peg$FAILED) {
                            s7 = [];
                            s8 = peg$currPos;
                            s9 = peg$parseupdate_stmt();
                            if (s9 === peg$FAILED) {
                                s9 = peg$parseinsert_stmt();
                                if (s9 === peg$FAILED) {
                                    s9 = peg$parsedelete_stmt();
                                    if (s9 === peg$FAILED) {
                                        s9 = peg$parseselect_stmt();
                                    }
                                }
                            }
                            if (s9 !== peg$FAILED) {
                                s10 = peg$parsesemicolon();
                                if (s10 !== peg$FAILED) {
                                    s9 = [s9, s10];
                                    s8 = s9;
                                }
                                else {
                                    peg$currPos = s8;
                                    s8 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s8;
                                s8 = peg$FAILED;
                            }
                            if (s8 !== peg$FAILED) {
                                while (s8 !== peg$FAILED) {
                                    s7.push(s8);
                                    s8 = peg$currPos;
                                    s9 = peg$parseupdate_stmt();
                                    if (s9 === peg$FAILED) {
                                        s9 = peg$parseinsert_stmt();
                                        if (s9 === peg$FAILED) {
                                            s9 = peg$parsedelete_stmt();
                                            if (s9 === peg$FAILED) {
                                                s9 = peg$parseselect_stmt();
                                            }
                                        }
                                    }
                                    if (s9 !== peg$FAILED) {
                                        s10 = peg$parsesemicolon();
                                        if (s10 !== peg$FAILED) {
                                            s9 = [s9, s10];
                                            s8 = s9;
                                        }
                                        else {
                                            peg$currPos = s8;
                                            s8 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s8;
                                        s8 = peg$FAILED;
                                    }
                                }
                            }
                            else {
                                s7 = peg$FAILED;
                            }
                            if (s7 !== peg$FAILED) {
                                s8 = peg$parseEND();
                                if (s8 !== peg$FAILED) {
                                    s6 = [s6, s7, s8];
                                    s5 = s6;
                                }
                                else {
                                    peg$currPos = s5;
                                    s5 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                        if (s5 !== peg$FAILED) {
                            s1 = [s1, s2, s3, s4, s5];
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsecreate_view_stmt() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseCREATE();
        if (s2 !== peg$FAILED) {
            s3 = peg$parseTEMP();
            if (s3 === peg$FAILED) {
                s3 = peg$parseTEMPORARY();
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parseVIEW();
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$parseIF();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parseNOT();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseEXISTS();
                            if (s8 !== peg$FAILED) {
                                s6 = [s6, s7, s8];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s2 = [s2, s3, s4, s5];
                        s1 = s2;
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$currPos;
            s4 = peg$parsename();
            if (s4 !== peg$FAILED) {
                s5 = peg$parsedot();
                if (s5 !== peg$FAILED) {
                    s4 = [s4, s5];
                    s3 = s4;
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parsename();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseAS();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parseselect_stmt();
                        if (s6 !== peg$FAILED) {
                            s3 = [s3, s4, s5, s6];
                            s2 = s3;
                        }
                        else {
                            peg$currPos = s2;
                            s2 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsecreate_virtual_table_stmt() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseCREATE();
        if (s2 !== peg$FAILED) {
            s3 = peg$parseVIRTUAL();
            if (s3 !== peg$FAILED) {
                s4 = peg$parseTABLE();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parsetable_ref();
                    if (s5 !== peg$FAILED) {
                        s2 = [s2, s3, s4, s5];
                        s1 = s2;
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parseUSING();
            if (s3 !== peg$FAILED) {
                s4 = peg$parsename();
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$parselparen();
                    if (s6 !== peg$FAILED) {
                        s7 = [];
                        s8 = peg$currPos;
                        s9 = peg$parsename();
                        if (s9 !== peg$FAILED) {
                            s10 = peg$parsecomma();
                            if (s10 !== peg$FAILED) {
                                s9 = [s9, s10];
                                s8 = s9;
                            }
                            else {
                                peg$currPos = s8;
                                s8 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s8;
                            s8 = peg$FAILED;
                        }
                        if (s8 !== peg$FAILED) {
                            while (s8 !== peg$FAILED) {
                                s7.push(s8);
                                s8 = peg$currPos;
                                s9 = peg$parsename();
                                if (s9 !== peg$FAILED) {
                                    s10 = peg$parsecomma();
                                    if (s10 !== peg$FAILED) {
                                        s9 = [s9, s10];
                                        s8 = s9;
                                    }
                                    else {
                                        peg$currPos = s8;
                                        s8 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s8;
                                    s8 = peg$FAILED;
                                }
                            }
                        }
                        else {
                            s7 = peg$FAILED;
                        }
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parserparen();
                            if (s8 !== peg$FAILED) {
                                s6 = [s6, s7, s8];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsedelete_stmt() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parseDELETE();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseFROM();
            if (s2 !== peg$FAILED) {
                s3 = peg$parsequalified_table_name();
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    s5 = peg$parseWHERE();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parseexpr();
                        if (s6 !== peg$FAILED) {
                            s5 = [s5, s6];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 === peg$FAILED) {
                        s4 = null;
                    }
                    if (s4 !== peg$FAILED) {
                        s1 = [s1, s2, s3, s4];
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsedelete_stmt_limited() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12;
        s0 = peg$currPos;
        s1 = peg$parseDELETE();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseFROM();
            if (s2 !== peg$FAILED) {
                s3 = peg$parsequalified_table_name();
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    s5 = peg$parseWHERE();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parseexpr();
                        if (s6 !== peg$FAILED) {
                            s5 = [s5, s6];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 === peg$FAILED) {
                        s4 = null;
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$currPos;
                        s6 = peg$currPos;
                        s7 = peg$parseORDER();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseBY();
                            if (s8 !== peg$FAILED) {
                                s9 = [];
                                s10 = peg$currPos;
                                s11 = peg$parseordering_term();
                                if (s11 !== peg$FAILED) {
                                    s12 = peg$parsecomma();
                                    if (s12 !== peg$FAILED) {
                                        s11 = [s11, s12];
                                        s10 = s11;
                                    }
                                    else {
                                        peg$currPos = s10;
                                        s10 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s10;
                                    s10 = peg$FAILED;
                                }
                                if (s10 !== peg$FAILED) {
                                    while (s10 !== peg$FAILED) {
                                        s9.push(s10);
                                        s10 = peg$currPos;
                                        s11 = peg$parseordering_term();
                                        if (s11 !== peg$FAILED) {
                                            s12 = peg$parsecomma();
                                            if (s12 !== peg$FAILED) {
                                                s11 = [s11, s12];
                                                s10 = s11;
                                            }
                                            else {
                                                peg$currPos = s10;
                                                s10 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s10;
                                            s10 = peg$FAILED;
                                        }
                                    }
                                }
                                else {
                                    s9 = peg$FAILED;
                                }
                                if (s9 !== peg$FAILED) {
                                    s7 = [s7, s8, s9];
                                    s6 = s7;
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                        if (s6 === peg$FAILED) {
                            s6 = null;
                        }
                        if (s6 !== peg$FAILED) {
                            s7 = peg$currPos;
                            s8 = peg$parseLIMIT();
                            if (s8 !== peg$FAILED) {
                                s9 = peg$parseexpr();
                                if (s9 !== peg$FAILED) {
                                    s10 = peg$currPos;
                                    s11 = peg$parseOFFSET();
                                    if (s11 === peg$FAILED) {
                                        s11 = peg$parsecomma();
                                    }
                                    if (s11 !== peg$FAILED) {
                                        s12 = peg$parseexpr();
                                        if (s12 !== peg$FAILED) {
                                            s11 = [s11, s12];
                                            s10 = s11;
                                        }
                                        else {
                                            peg$currPos = s10;
                                            s10 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s10;
                                        s10 = peg$FAILED;
                                    }
                                    if (s10 === peg$FAILED) {
                                        s10 = null;
                                    }
                                    if (s10 !== peg$FAILED) {
                                        s8 = [s8, s9, s10];
                                        s7 = s8;
                                    }
                                    else {
                                        peg$currPos = s7;
                                        s7 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s7;
                                    s7 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s7;
                                s7 = peg$FAILED;
                            }
                            if (s7 !== peg$FAILED) {
                                s6 = [s6, s7];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                        if (s5 === peg$FAILED) {
                            s5 = null;
                        }
                        if (s5 !== peg$FAILED) {
                            s1 = [s1, s2, s3, s4, s5];
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsedetach_stmt() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$parseDETACH();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseDATABASE();
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parsename();
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsedrop_index_stmt() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parseDROP();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseINDEX();
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parseIF();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseEXISTS();
                    if (s5 !== peg$FAILED) {
                        s4 = [s4, s5];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                    s3 = null;
                }
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    s5 = peg$parsename();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsedot();
                        if (s6 !== peg$FAILED) {
                            s5 = [s5, s6];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 === peg$FAILED) {
                        s4 = null;
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parsename();
                        if (s5 !== peg$FAILED) {
                            s1 = [s1, s2, s3, s4, s5];
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsedrop_table_stmt() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseDROP();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseTABLE();
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parseIF();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseEXISTS();
                    if (s5 !== peg$FAILED) {
                        s4 = [s4, s5];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                    s3 = null;
                }
                if (s3 !== peg$FAILED) {
                    s4 = peg$parsetable_ref();
                    if (s4 !== peg$FAILED) {
                        s1 = [s1, s2, s3, s4];
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsedrop_trigger_stmt() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parseDROP();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseTRIGGER();
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parseIF();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseEXISTS();
                    if (s5 !== peg$FAILED) {
                        s4 = [s4, s5];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                    s3 = null;
                }
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    s5 = peg$parsename();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsedot();
                        if (s6 !== peg$FAILED) {
                            s5 = [s5, s6];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 === peg$FAILED) {
                        s4 = null;
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parsename();
                        if (s5 !== peg$FAILED) {
                            s1 = [s1, s2, s3, s4, s5];
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsedrop_view_stmt() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parseDROP();
        if (s1 !== peg$FAILED) {
            s2 = peg$parseVIEW();
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parseIF();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseEXISTS();
                    if (s5 !== peg$FAILED) {
                        s4 = [s4, s5];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                    s3 = null;
                }
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    s5 = peg$parsename();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsedot();
                        if (s6 !== peg$FAILED) {
                            s5 = [s5, s6];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 === peg$FAILED) {
                        s4 = null;
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parsename();
                        if (s5 !== peg$FAILED) {
                            s1 = [s1, s2, s3, s4, s5];
                            s0 = s1;
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsevalue() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parsewhitespace();
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$parseliteral_value();
            if (s4 !== peg$FAILED) {
                peg$savedPos = s3;
                s4 = peg$c2(s4);
            }
            s3 = s4;
            if (s3 === peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parsebind_parameter();
                if (s4 !== peg$FAILED) {
                    peg$savedPos = s3;
                    s4 = peg$c3(s4);
                }
                s3 = s4;
                if (s3 === peg$FAILED) {
                    s3 = peg$currPos;
                    s4 = peg$currPos;
                    s5 = peg$parsename();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsedot();
                        if (s6 !== peg$FAILED) {
                            s7 = peg$parsename();
                            if (s7 !== peg$FAILED) {
                                s5 = [s5, s6, s7];
                                s4 = s5;
                            }
                            else {
                                peg$currPos = s4;
                                s4 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 !== peg$FAILED) {
                        peg$savedPos = s3;
                        s4 = peg$c4(s4);
                    }
                    s3 = s4;
                    if (s3 === peg$FAILED) {
                        s3 = peg$currPos;
                        s4 = peg$parsename();
                        if (s4 !== peg$FAILED) {
                            peg$savedPos = s3;
                            s4 = peg$c5(s4);
                        }
                        s3 = s4;
                        if (s3 === peg$FAILED) {
                            s3 = peg$currPos;
                            s4 = peg$parseunary_operator();
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parseexpr();
                                if (s5 !== peg$FAILED) {
                                    s4 = [s4, s5];
                                    s3 = s4;
                                }
                                else {
                                    peg$currPos = s3;
                                    s3 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                            }
                            if (s3 === peg$FAILED) {
                                s3 = peg$parsecall_function();
                                if (s3 === peg$FAILED) {
                                    s3 = peg$currPos;
                                    s4 = peg$parsewhitespace();
                                    if (s4 !== peg$FAILED) {
                                        s5 = peg$parselparen();
                                        if (s5 !== peg$FAILED) {
                                            s6 = peg$parseexpr();
                                            if (s6 !== peg$FAILED) {
                                                s7 = peg$parsewhitespace();
                                                if (s7 !== peg$FAILED) {
                                                    s8 = peg$parserparen();
                                                    if (s8 !== peg$FAILED) {
                                                        s4 = [s4, s5, s6, s7, s8];
                                                        s3 = s4;
                                                    }
                                                    else {
                                                        peg$currPos = s3;
                                                        s3 = peg$FAILED;
                                                    }
                                                }
                                                else {
                                                    peg$currPos = s3;
                                                    s3 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s3;
                                                s3 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s3;
                                            s3 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s3;
                                        s3 = peg$FAILED;
                                    }
                                    if (s3 === peg$FAILED) {
                                        s3 = peg$currPos;
                                        s4 = peg$parseCAST();
                                        if (s4 !== peg$FAILED) {
                                            s5 = peg$parselparen();
                                            if (s5 !== peg$FAILED) {
                                                s6 = peg$parseexpr();
                                                if (s6 !== peg$FAILED) {
                                                    s7 = peg$parseAS();
                                                    if (s7 !== peg$FAILED) {
                                                        s8 = peg$parsetype_name();
                                                        if (s8 !== peg$FAILED) {
                                                            s9 = peg$parserparen();
                                                            if (s9 !== peg$FAILED) {
                                                                s4 = [s4, s5, s6, s7, s8, s9];
                                                                s3 = s4;
                                                            }
                                                            else {
                                                                peg$currPos = s3;
                                                                s3 = peg$FAILED;
                                                            }
                                                        }
                                                        else {
                                                            peg$currPos = s3;
                                                            s3 = peg$FAILED;
                                                        }
                                                    }
                                                    else {
                                                        peg$currPos = s3;
                                                        s3 = peg$FAILED;
                                                    }
                                                }
                                                else {
                                                    peg$currPos = s3;
                                                    s3 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s3;
                                                s3 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s3;
                                            s3 = peg$FAILED;
                                        }
                                        if (s3 === peg$FAILED) {
                                            s3 = peg$currPos;
                                            s4 = peg$currPos;
                                            s5 = peg$parseNOT();
                                            if (s5 === peg$FAILED) {
                                                s5 = null;
                                            }
                                            if (s5 !== peg$FAILED) {
                                                s6 = peg$parseEXISTS();
                                                if (s6 !== peg$FAILED) {
                                                    s5 = [s5, s6];
                                                    s4 = s5;
                                                }
                                                else {
                                                    peg$currPos = s4;
                                                    s4 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s4;
                                                s4 = peg$FAILED;
                                            }
                                            if (s4 === peg$FAILED) {
                                                s4 = null;
                                            }
                                            if (s4 !== peg$FAILED) {
                                                s5 = peg$parselparen();
                                                if (s5 !== peg$FAILED) {
                                                    s6 = peg$parseselect_stmt();
                                                    if (s6 !== peg$FAILED) {
                                                        s7 = peg$parserparen();
                                                        if (s7 !== peg$FAILED) {
                                                            s4 = [s4, s5, s6, s7];
                                                            s3 = s4;
                                                        }
                                                        else {
                                                            peg$currPos = s3;
                                                            s3 = peg$FAILED;
                                                        }
                                                    }
                                                    else {
                                                        peg$currPos = s3;
                                                        s3 = peg$FAILED;
                                                    }
                                                }
                                                else {
                                                    peg$currPos = s3;
                                                    s3 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s3;
                                                s3 = peg$FAILED;
                                            }
                                            if (s3 === peg$FAILED) {
                                                s3 = peg$currPos;
                                                s4 = peg$parseCASE();
                                                if (s4 !== peg$FAILED) {
                                                    s5 = peg$parseexpr();
                                                    if (s5 === peg$FAILED) {
                                                        s5 = null;
                                                    }
                                                    if (s5 !== peg$FAILED) {
                                                        s6 = [];
                                                        s7 = peg$currPos;
                                                        s8 = peg$parseWHEN();
                                                        if (s8 !== peg$FAILED) {
                                                            s9 = peg$parseexpr();
                                                            if (s9 !== peg$FAILED) {
                                                                s10 = peg$parseTHEN();
                                                                if (s10 !== peg$FAILED) {
                                                                    s11 = peg$parseexpr();
                                                                    if (s11 !== peg$FAILED) {
                                                                        s8 = [s8, s9, s10, s11];
                                                                        s7 = s8;
                                                                    }
                                                                    else {
                                                                        peg$currPos = s7;
                                                                        s7 = peg$FAILED;
                                                                    }
                                                                }
                                                                else {
                                                                    peg$currPos = s7;
                                                                    s7 = peg$FAILED;
                                                                }
                                                            }
                                                            else {
                                                                peg$currPos = s7;
                                                                s7 = peg$FAILED;
                                                            }
                                                        }
                                                        else {
                                                            peg$currPos = s7;
                                                            s7 = peg$FAILED;
                                                        }
                                                        if (s7 !== peg$FAILED) {
                                                            while (s7 !== peg$FAILED) {
                                                                s6.push(s7);
                                                                s7 = peg$currPos;
                                                                s8 = peg$parseWHEN();
                                                                if (s8 !== peg$FAILED) {
                                                                    s9 = peg$parseexpr();
                                                                    if (s9 !== peg$FAILED) {
                                                                        s10 = peg$parseTHEN();
                                                                        if (s10 !== peg$FAILED) {
                                                                            s11 = peg$parseexpr();
                                                                            if (s11 !== peg$FAILED) {
                                                                                s8 = [s8, s9, s10, s11];
                                                                                s7 = s8;
                                                                            }
                                                                            else {
                                                                                peg$currPos = s7;
                                                                                s7 = peg$FAILED;
                                                                            }
                                                                        }
                                                                        else {
                                                                            peg$currPos = s7;
                                                                            s7 = peg$FAILED;
                                                                        }
                                                                    }
                                                                    else {
                                                                        peg$currPos = s7;
                                                                        s7 = peg$FAILED;
                                                                    }
                                                                }
                                                                else {
                                                                    peg$currPos = s7;
                                                                    s7 = peg$FAILED;
                                                                }
                                                            }
                                                        }
                                                        else {
                                                            s6 = peg$FAILED;
                                                        }
                                                        if (s6 !== peg$FAILED) {
                                                            s7 = peg$currPos;
                                                            s8 = peg$parseELSE();
                                                            if (s8 !== peg$FAILED) {
                                                                s9 = peg$parseexpr();
                                                                if (s9 !== peg$FAILED) {
                                                                    s8 = [s8, s9];
                                                                    s7 = s8;
                                                                }
                                                                else {
                                                                    peg$currPos = s7;
                                                                    s7 = peg$FAILED;
                                                                }
                                                            }
                                                            else {
                                                                peg$currPos = s7;
                                                                s7 = peg$FAILED;
                                                            }
                                                            if (s7 === peg$FAILED) {
                                                                s7 = null;
                                                            }
                                                            if (s7 !== peg$FAILED) {
                                                                s8 = peg$parseEND();
                                                                if (s8 !== peg$FAILED) {
                                                                    s4 = [s4, s5, s6, s7, s8];
                                                                    s3 = s4;
                                                                }
                                                                else {
                                                                    peg$currPos = s3;
                                                                    s3 = peg$FAILED;
                                                                }
                                                            }
                                                            else {
                                                                peg$currPos = s3;
                                                                s3 = peg$FAILED;
                                                            }
                                                        }
                                                        else {
                                                            peg$currPos = s3;
                                                            s3 = peg$FAILED;
                                                        }
                                                    }
                                                    else {
                                                        peg$currPos = s3;
                                                        s3 = peg$FAILED;
                                                    }
                                                }
                                                else {
                                                    peg$currPos = s3;
                                                    s3 = peg$FAILED;
                                                }
                                                if (s3 === peg$FAILED) {
                                                    s3 = peg$parseraise_function();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c6(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseexpr() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parsewhitespace();
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$parsevalue();
            if (s4 !== peg$FAILED) {
                s5 = peg$parsebinary_operator();
                if (s5 !== peg$FAILED) {
                    s6 = peg$parseexpr();
                    if (s6 !== peg$FAILED) {
                        s4 = [s4, s5, s6];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parsevalue();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseCOLLATE();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsename();
                        if (s6 !== peg$FAILED) {
                            s4 = [s4, s5, s6];
                            s3 = s4;
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                    s3 = peg$currPos;
                    s4 = peg$parsevalue();
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseNOT();
                        if (s5 === peg$FAILED) {
                            s5 = null;
                        }
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parseLIKE();
                            if (s6 === peg$FAILED) {
                                s6 = peg$parseGLOB();
                                if (s6 === peg$FAILED) {
                                    s6 = peg$parseREGEXP();
                                    if (s6 === peg$FAILED) {
                                        s6 = peg$parseMATCH();
                                    }
                                }
                            }
                            if (s6 !== peg$FAILED) {
                                s7 = peg$parseexpr();
                                if (s7 !== peg$FAILED) {
                                    s8 = peg$currPos;
                                    s9 = peg$parseESCAPE();
                                    if (s9 !== peg$FAILED) {
                                        s10 = peg$parseexpr();
                                        if (s10 !== peg$FAILED) {
                                            s9 = [s9, s10];
                                            s8 = s9;
                                        }
                                        else {
                                            peg$currPos = s8;
                                            s8 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s8;
                                        s8 = peg$FAILED;
                                    }
                                    if (s8 === peg$FAILED) {
                                        s8 = null;
                                    }
                                    if (s8 !== peg$FAILED) {
                                        s4 = [s4, s5, s6, s7, s8];
                                        s3 = s4;
                                    }
                                    else {
                                        peg$currPos = s3;
                                        s3 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s3;
                                    s3 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                    if (s3 === peg$FAILED) {
                        s3 = peg$currPos;
                        s4 = peg$parsevalue();
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parseISNULL();
                            if (s5 === peg$FAILED) {
                                s5 = peg$parseNOTNULL();
                                if (s5 === peg$FAILED) {
                                    s5 = peg$currPos;
                                    s6 = peg$parseNOT();
                                    if (s6 !== peg$FAILED) {
                                        s7 = peg$parseNULL();
                                        if (s7 !== peg$FAILED) {
                                            s6 = [s6, s7];
                                            s5 = s6;
                                        }
                                        else {
                                            peg$currPos = s5;
                                            s5 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s5;
                                        s5 = peg$FAILED;
                                    }
                                }
                            }
                            if (s5 !== peg$FAILED) {
                                s4 = [s4, s5];
                                s3 = s4;
                            }
                            else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                        if (s3 === peg$FAILED) {
                            s3 = peg$currPos;
                            s4 = peg$parsevalue();
                            if (s4 !== peg$FAILED) {
                                s5 = peg$parseIS();
                                if (s5 !== peg$FAILED) {
                                    s6 = peg$parseNOT();
                                    if (s6 === peg$FAILED) {
                                        s6 = null;
                                    }
                                    if (s6 !== peg$FAILED) {
                                        s7 = peg$parseexpr();
                                        if (s7 !== peg$FAILED) {
                                            s4 = [s4, s5, s6, s7];
                                            s3 = s4;
                                        }
                                        else {
                                            peg$currPos = s3;
                                            s3 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s3;
                                        s3 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s3;
                                    s3 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                            }
                            if (s3 === peg$FAILED) {
                                s3 = peg$currPos;
                                s4 = peg$parsevalue();
                                if (s4 !== peg$FAILED) {
                                    s5 = peg$parseNOT();
                                    if (s5 === peg$FAILED) {
                                        s5 = null;
                                    }
                                    if (s5 !== peg$FAILED) {
                                        s6 = peg$parseBETWEEN();
                                        if (s6 !== peg$FAILED) {
                                            s7 = peg$parseexpr();
                                            if (s7 !== peg$FAILED) {
                                                s8 = peg$parseAND();
                                                if (s8 !== peg$FAILED) {
                                                    s9 = peg$parseexpr();
                                                    if (s9 !== peg$FAILED) {
                                                        s4 = [s4, s5, s6, s7, s8, s9];
                                                        s3 = s4;
                                                    }
                                                    else {
                                                        peg$currPos = s3;
                                                        s3 = peg$FAILED;
                                                    }
                                                }
                                                else {
                                                    peg$currPos = s3;
                                                    s3 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s3;
                                                s3 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s3;
                                            s3 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s3;
                                        s3 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s3;
                                    s3 = peg$FAILED;
                                }
                                if (s3 === peg$FAILED) {
                                    s3 = peg$currPos;
                                    s4 = peg$parsevalue();
                                    if (s4 !== peg$FAILED) {
                                        s5 = peg$parseNOT();
                                        if (s5 === peg$FAILED) {
                                            s5 = null;
                                        }
                                        if (s5 !== peg$FAILED) {
                                            s6 = peg$parseIN();
                                            if (s6 !== peg$FAILED) {
                                                s7 = peg$currPos;
                                                s8 = peg$parselparen();
                                                if (s8 !== peg$FAILED) {
                                                    s9 = peg$parseselect_stmt();
                                                    if (s9 === peg$FAILED) {
                                                        s9 = [];
                                                        s10 = peg$currPos;
                                                        s11 = peg$parseexpr();
                                                        if (s11 !== peg$FAILED) {
                                                            s12 = peg$parsecomma();
                                                            if (s12 !== peg$FAILED) {
                                                                s11 = [s11, s12];
                                                                s10 = s11;
                                                            }
                                                            else {
                                                                peg$currPos = s10;
                                                                s10 = peg$FAILED;
                                                            }
                                                        }
                                                        else {
                                                            peg$currPos = s10;
                                                            s10 = peg$FAILED;
                                                        }
                                                        if (s10 !== peg$FAILED) {
                                                            while (s10 !== peg$FAILED) {
                                                                s9.push(s10);
                                                                s10 = peg$currPos;
                                                                s11 = peg$parseexpr();
                                                                if (s11 !== peg$FAILED) {
                                                                    s12 = peg$parsecomma();
                                                                    if (s12 !== peg$FAILED) {
                                                                        s11 = [s11, s12];
                                                                        s10 = s11;
                                                                    }
                                                                    else {
                                                                        peg$currPos = s10;
                                                                        s10 = peg$FAILED;
                                                                    }
                                                                }
                                                                else {
                                                                    peg$currPos = s10;
                                                                    s10 = peg$FAILED;
                                                                }
                                                            }
                                                        }
                                                        else {
                                                            s9 = peg$FAILED;
                                                        }
                                                    }
                                                    if (s9 === peg$FAILED) {
                                                        s9 = null;
                                                    }
                                                    if (s9 !== peg$FAILED) {
                                                        s10 = peg$parserparen();
                                                        if (s10 !== peg$FAILED) {
                                                            s8 = [s8, s9, s10];
                                                            s7 = s8;
                                                        }
                                                        else {
                                                            peg$currPos = s7;
                                                            s7 = peg$FAILED;
                                                        }
                                                    }
                                                    else {
                                                        peg$currPos = s7;
                                                        s7 = peg$FAILED;
                                                    }
                                                }
                                                else {
                                                    peg$currPos = s7;
                                                    s7 = peg$FAILED;
                                                }
                                                if (s7 === peg$FAILED) {
                                                    s7 = peg$parsetable_ref();
                                                }
                                                if (s7 !== peg$FAILED) {
                                                    s4 = [s4, s5, s6, s7];
                                                    s3 = s4;
                                                }
                                                else {
                                                    peg$currPos = s3;
                                                    s3 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s3;
                                                s3 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s3;
                                            s3 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s3;
                                        s3 = peg$FAILED;
                                    }
                                    if (s3 === peg$FAILED) {
                                        s3 = peg$parsevalue();
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c7(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsecall_function() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13;
        s0 = peg$currPos;
        s1 = peg$parsename();
        if (s1 !== peg$FAILED) {
            s2 = peg$parsewhitespace();
            if (s2 !== peg$FAILED) {
                s3 = peg$parselparen();
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    s5 = peg$parseDISTINCT();
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s6 = [];
                        s7 = peg$currPos;
                        s8 = peg$parseexpr();
                        if (s8 !== peg$FAILED) {
                            s9 = [];
                            s10 = peg$currPos;
                            s11 = peg$parsewhitespace();
                            if (s11 !== peg$FAILED) {
                                s12 = peg$parsecomma();
                                if (s12 !== peg$FAILED) {
                                    s13 = peg$parseexpr();
                                    if (s13 !== peg$FAILED) {
                                        s11 = [s11, s12, s13];
                                        s10 = s11;
                                    }
                                    else {
                                        peg$currPos = s10;
                                        s10 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s10;
                                    s10 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s10;
                                s10 = peg$FAILED;
                            }
                            while (s10 !== peg$FAILED) {
                                s9.push(s10);
                                s10 = peg$currPos;
                                s11 = peg$parsewhitespace();
                                if (s11 !== peg$FAILED) {
                                    s12 = peg$parsecomma();
                                    if (s12 !== peg$FAILED) {
                                        s13 = peg$parseexpr();
                                        if (s13 !== peg$FAILED) {
                                            s11 = [s11, s12, s13];
                                            s10 = s11;
                                        }
                                        else {
                                            peg$currPos = s10;
                                            s10 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s10;
                                        s10 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s10;
                                    s10 = peg$FAILED;
                                }
                            }
                            if (s9 !== peg$FAILED) {
                                s8 = [s8, s9];
                                s7 = s8;
                            }
                            else {
                                peg$currPos = s7;
                                s7 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s7;
                            s7 = peg$FAILED;
                        }
                        if (s7 !== peg$FAILED) {
                            while (s7 !== peg$FAILED) {
                                s6.push(s7);
                                s7 = peg$currPos;
                                s8 = peg$parseexpr();
                                if (s8 !== peg$FAILED) {
                                    s9 = [];
                                    s10 = peg$currPos;
                                    s11 = peg$parsewhitespace();
                                    if (s11 !== peg$FAILED) {
                                        s12 = peg$parsecomma();
                                        if (s12 !== peg$FAILED) {
                                            s13 = peg$parseexpr();
                                            if (s13 !== peg$FAILED) {
                                                s11 = [s11, s12, s13];
                                                s10 = s11;
                                            }
                                            else {
                                                peg$currPos = s10;
                                                s10 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s10;
                                            s10 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s10;
                                        s10 = peg$FAILED;
                                    }
                                    while (s10 !== peg$FAILED) {
                                        s9.push(s10);
                                        s10 = peg$currPos;
                                        s11 = peg$parsewhitespace();
                                        if (s11 !== peg$FAILED) {
                                            s12 = peg$parsecomma();
                                            if (s12 !== peg$FAILED) {
                                                s13 = peg$parseexpr();
                                                if (s13 !== peg$FAILED) {
                                                    s11 = [s11, s12, s13];
                                                    s10 = s11;
                                                }
                                                else {
                                                    peg$currPos = s10;
                                                    s10 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s10;
                                                s10 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s10;
                                            s10 = peg$FAILED;
                                        }
                                    }
                                    if (s9 !== peg$FAILED) {
                                        s8 = [s8, s9];
                                        s7 = s8;
                                    }
                                    else {
                                        peg$currPos = s7;
                                        s7 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s7;
                                    s7 = peg$FAILED;
                                }
                            }
                        }
                        else {
                            s6 = peg$FAILED;
                        }
                        if (s6 !== peg$FAILED) {
                            s5 = [s5, s6];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 === peg$FAILED) {
                        s4 = peg$currPos;
                        s5 = peg$parsewhitespace();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parsestar();
                            if (s6 !== peg$FAILED) {
                                s5 = [s5, s6];
                                s4 = s5;
                            }
                            else {
                                peg$currPos = s4;
                                s4 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    if (s4 === peg$FAILED) {
                        s4 = null;
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parsewhitespace();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parserparen();
                            if (s6 !== peg$FAILED) {
                                s1 = [s1, s2, s3, s4, s5, s6];
                                s0 = s1;
                            }
                            else {
                                peg$currPos = s0;
                                s0 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseraise_function() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parseRAISE();
        if (s1 !== peg$FAILED) {
            s2 = peg$parselparen();
            if (s2 !== peg$FAILED) {
                s3 = peg$parseIGNORE();
                if (s3 === peg$FAILED) {
                    s3 = peg$currPos;
                    s4 = peg$parseROLLBACK();
                    if (s4 === peg$FAILED) {
                        s4 = peg$parseABORT();
                        if (s4 === peg$FAILED) {
                            s4 = peg$parseFAIL();
                        }
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parsecomma();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parsestring_literal();
                            if (s6 !== peg$FAILED) {
                                s4 = [s4, s5, s6];
                                s3 = s4;
                            }
                            else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                if (s3 !== peg$FAILED) {
                    s4 = peg$parserparen();
                    if (s4 !== peg$FAILED) {
                        s1 = [s1, s2, s3, s4];
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseliteral_value() {
        var s0;
        s0 = peg$parsenumeric_literal();
        if (s0 === peg$FAILED) {
            s0 = peg$parsestring_literal();
            if (s0 === peg$FAILED) {
                s0 = peg$parsestring_literal();
                if (s0 === peg$FAILED) {
                    s0 = peg$parseNULL();
                    if (s0 === peg$FAILED) {
                        s0 = peg$parseCURRENT_TIME();
                        if (s0 === peg$FAILED) {
                            s0 = peg$parseCURRENT_DATE();
                            if (s0 === peg$FAILED) {
                                s0 = peg$parseCURRENT_TIMESTAMP();
                            }
                        }
                    }
                }
            }
        }
        return s0;
    }
    function peg$parsenumeric_literal() {
        var s0, s1, s2, s3, s4, s5, s6, s7;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$currPos;
        s3 = [];
        s4 = peg$parsedigit();
        if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
                s3.push(s4);
                s4 = peg$parsedigit();
            }
        }
        else {
            s3 = peg$FAILED;
        }
        if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            s5 = peg$parsedot();
            if (s5 !== peg$FAILED) {
                s6 = [];
                s7 = peg$parsedigit();
                if (s7 !== peg$FAILED) {
                    while (s7 !== peg$FAILED) {
                        s6.push(s7);
                        s7 = peg$parsedigit();
                    }
                }
                else {
                    s6 = peg$FAILED;
                }
                if (s6 !== peg$FAILED) {
                    s5 = [s5, s6];
                    s4 = s5;
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s4;
                s4 = peg$FAILED;
            }
            if (s4 === peg$FAILED) {
                s4 = null;
            }
            if (s4 !== peg$FAILED) {
                s3 = [s3, s4];
                s2 = s3;
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s2;
            s2 = peg$FAILED;
        }
        if (s2 === peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parsedot();
            if (s3 !== peg$FAILED) {
                s4 = [];
                s5 = peg$parsedigit();
                if (s5 !== peg$FAILED) {
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$parsedigit();
                    }
                }
                else {
                    s4 = peg$FAILED;
                }
                if (s4 !== peg$FAILED) {
                    s3 = [s3, s4];
                    s2 = s3;
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
        }
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$parseE();
            if (s4 !== peg$FAILED) {
                s5 = peg$parseplus();
                if (s5 === peg$FAILED) {
                    s5 = peg$parseminus();
                }
                if (s5 === peg$FAILED) {
                    s5 = null;
                }
                if (s5 !== peg$FAILED) {
                    s6 = [];
                    s7 = peg$parsedigit();
                    if (s7 !== peg$FAILED) {
                        while (s7 !== peg$FAILED) {
                            s6.push(s7);
                            s7 = peg$parsedigit();
                        }
                    }
                    else {
                        s6 = peg$FAILED;
                    }
                    if (s6 !== peg$FAILED) {
                        s4 = [s4, s5, s6];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c8(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseinsert_stmt() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseINSERT();
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$parseOR();
            if (s4 !== peg$FAILED) {
                s5 = peg$parseROLLBACK();
                if (s5 === peg$FAILED) {
                    s5 = peg$parseABORT();
                    if (s5 === peg$FAILED) {
                        s5 = peg$parseREPLACE();
                        if (s5 === peg$FAILED) {
                            s5 = peg$parseFAIL();
                            if (s5 === peg$FAILED) {
                                s5 = peg$parseIGNORE();
                            }
                        }
                    }
                }
                if (s5 !== peg$FAILED) {
                    s4 = [s4, s5];
                    s3 = s4;
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 === peg$FAILED) {
            s1 = peg$parseREPLACE();
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$parseINTO();
            if (s2 !== peg$FAILED) {
                s3 = peg$parsetable_ref();
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    s5 = peg$currPos;
                    s6 = peg$parselparen();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$currPos;
                        s8 = peg$parsename();
                        if (s8 !== peg$FAILED) {
                            s9 = [];
                            s10 = peg$currPos;
                            s11 = peg$parsecomma();
                            if (s11 !== peg$FAILED) {
                                s12 = peg$parsename();
                                if (s12 !== peg$FAILED) {
                                    s11 = [s11, s12];
                                    s10 = s11;
                                }
                                else {
                                    peg$currPos = s10;
                                    s10 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s10;
                                s10 = peg$FAILED;
                            }
                            while (s10 !== peg$FAILED) {
                                s9.push(s10);
                                s10 = peg$currPos;
                                s11 = peg$parsecomma();
                                if (s11 !== peg$FAILED) {
                                    s12 = peg$parsename();
                                    if (s12 !== peg$FAILED) {
                                        s11 = [s11, s12];
                                        s10 = s11;
                                    }
                                    else {
                                        peg$currPos = s10;
                                        s10 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s10;
                                    s10 = peg$FAILED;
                                }
                            }
                            if (s9 !== peg$FAILED) {
                                s8 = [s8, s9];
                                s7 = s8;
                            }
                            else {
                                peg$currPos = s7;
                                s7 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s7;
                            s7 = peg$FAILED;
                        }
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parserparen();
                            if (s8 !== peg$FAILED) {
                                s6 = [s6, s7, s8];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s6 = peg$currPos;
                        s7 = peg$parseVALUES();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parselparen();
                            if (s8 !== peg$FAILED) {
                                s9 = [];
                                s10 = peg$currPos;
                                s11 = peg$parseexpr();
                                if (s11 !== peg$FAILED) {
                                    s12 = peg$parsecomma();
                                    if (s12 !== peg$FAILED) {
                                        s11 = [s11, s12];
                                        s10 = s11;
                                    }
                                    else {
                                        peg$currPos = s10;
                                        s10 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s10;
                                    s10 = peg$FAILED;
                                }
                                if (s10 !== peg$FAILED) {
                                    while (s10 !== peg$FAILED) {
                                        s9.push(s10);
                                        s10 = peg$currPos;
                                        s11 = peg$parseexpr();
                                        if (s11 !== peg$FAILED) {
                                            s12 = peg$parsecomma();
                                            if (s12 !== peg$FAILED) {
                                                s11 = [s11, s12];
                                                s10 = s11;
                                            }
                                            else {
                                                peg$currPos = s10;
                                                s10 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s10;
                                            s10 = peg$FAILED;
                                        }
                                    }
                                }
                                else {
                                    s9 = peg$FAILED;
                                }
                                if (s9 !== peg$FAILED) {
                                    s10 = peg$parserparen();
                                    if (s10 !== peg$FAILED) {
                                        s7 = [s7, s8, s9, s10];
                                        s6 = s7;
                                    }
                                    else {
                                        peg$currPos = s6;
                                        s6 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                        if (s6 === peg$FAILED) {
                            s6 = peg$parseselect_stmt();
                        }
                        if (s6 !== peg$FAILED) {
                            s5 = [s5, s6];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 === peg$FAILED) {
                        s4 = peg$currPos;
                        s5 = peg$parseDEFAULT();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parseVALUES();
                            if (s6 !== peg$FAILED) {
                                s5 = [s5, s6];
                                s4 = s5;
                            }
                            else {
                                peg$currPos = s4;
                                s4 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    if (s4 !== peg$FAILED) {
                        s1 = [s1, s2, s3, s4];
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsepragma_stmt() {
        var s0, s1, s2, s3, s4, s5, s6, s7;
        s0 = peg$currPos;
        s1 = peg$parsePRAGMA();
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parsename();
            if (s3 !== peg$FAILED) {
                s4 = peg$parsedot();
                if (s4 !== peg$FAILED) {
                    s3 = [s3, s4];
                    s2 = s3;
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parsename();
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    s5 = peg$parseequal();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsepragma_value();
                        if (s6 !== peg$FAILED) {
                            s5 = [s5, s6];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                    if (s4 === peg$FAILED) {
                        s4 = peg$currPos;
                        s5 = peg$parselparen();
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parsepragma_value();
                            if (s6 !== peg$FAILED) {
                                s7 = peg$parserparen();
                                if (s7 !== peg$FAILED) {
                                    s5 = [s5, s6, s7];
                                    s4 = s5;
                                }
                                else {
                                    peg$currPos = s4;
                                    s4 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s4;
                                s4 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    if (s4 === peg$FAILED) {
                        s4 = null;
                    }
                    if (s4 !== peg$FAILED) {
                        s1 = [s1, s2, s3, s4];
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsepragma_value() {
        var s0;
        s0 = peg$parsesigned_number();
        if (s0 === peg$FAILED) {
            s0 = peg$parsename();
            if (s0 === peg$FAILED) {
                s0 = peg$parsestring_literal();
            }
        }
        return s0;
    }
    function peg$parsereindex_stmt() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseREINDEX();
        if (s1 !== peg$FAILED) {
            s2 = peg$parsename();
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$parsetable_ref();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parsename();
                    if (s5 !== peg$FAILED) {
                        s4 = [s4, s5];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseselect_stmt() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$currPos;
        s3 = peg$parseselect_core();
        if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            s5 = [];
            s6 = peg$currPos;
            s7 = peg$parsecompound_operator();
            if (s7 !== peg$FAILED) {
                s8 = peg$parseselect_core();
                if (s8 !== peg$FAILED) {
                    s7 = [s7, s8];
                    s6 = s7;
                }
                else {
                    peg$currPos = s6;
                    s6 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s6;
                s6 = peg$FAILED;
            }
            while (s6 !== peg$FAILED) {
                s5.push(s6);
                s6 = peg$currPos;
                s7 = peg$parsecompound_operator();
                if (s7 !== peg$FAILED) {
                    s8 = peg$parseselect_core();
                    if (s8 !== peg$FAILED) {
                        s7 = [s7, s8];
                        s6 = s7;
                    }
                    else {
                        peg$currPos = s6;
                        s6 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s6;
                    s6 = peg$FAILED;
                }
            }
            if (s5 !== peg$FAILED) {
                peg$savedPos = s4;
                s5 = peg$c9(s5);
            }
            s4 = s5;
            if (s4 !== peg$FAILED) {
                s3 = [s3, s4];
                s2 = s3;
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s2;
            s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$parseORDER();
            if (s4 !== peg$FAILED) {
                s5 = peg$parseBY();
                if (s5 !== peg$FAILED) {
                    s6 = peg$parseordering_term();
                    if (s6 !== peg$FAILED) {
                        s7 = [];
                        s8 = peg$currPos;
                        s9 = peg$parsewhitespace();
                        if (s9 !== peg$FAILED) {
                            s10 = peg$parsecomma();
                            if (s10 !== peg$FAILED) {
                                s11 = peg$parseordering_term();
                                if (s11 !== peg$FAILED) {
                                    s9 = [s9, s10, s11];
                                    s8 = s9;
                                }
                                else {
                                    peg$currPos = s8;
                                    s8 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s8;
                                s8 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s8;
                            s8 = peg$FAILED;
                        }
                        while (s8 !== peg$FAILED) {
                            s7.push(s8);
                            s8 = peg$currPos;
                            s9 = peg$parsewhitespace();
                            if (s9 !== peg$FAILED) {
                                s10 = peg$parsecomma();
                                if (s10 !== peg$FAILED) {
                                    s11 = peg$parseordering_term();
                                    if (s11 !== peg$FAILED) {
                                        s9 = [s9, s10, s11];
                                        s8 = s9;
                                    }
                                    else {
                                        peg$currPos = s8;
                                        s8 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s8;
                                    s8 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s8;
                                s8 = peg$FAILED;
                            }
                        }
                        if (s7 !== peg$FAILED) {
                            s4 = [s4, s5, s6, s7];
                            s3 = s4;
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$currPos;
                s5 = peg$parseLIMIT();
                if (s5 !== peg$FAILED) {
                    s6 = peg$parseexpr();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$currPos;
                        s8 = peg$parseOFFSET();
                        if (s8 === peg$FAILED) {
                            s8 = peg$parsecomma();
                        }
                        if (s8 !== peg$FAILED) {
                            s9 = peg$parseexpr();
                            if (s9 !== peg$FAILED) {
                                s8 = [s8, s9];
                                s7 = s8;
                            }
                            else {
                                peg$currPos = s7;
                                s7 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s7;
                            s7 = peg$FAILED;
                        }
                        if (s7 === peg$FAILED) {
                            s7 = null;
                        }
                        if (s7 !== peg$FAILED) {
                            s5 = [s5, s6, s7];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
                if (s4 === peg$FAILED) {
                    s4 = null;
                }
                if (s4 !== peg$FAILED) {
                    s2 = [s2, s3, s4];
                    s1 = s2;
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c10();
        }
        s0 = s1;
        return s0;
    }
    function peg$parseselect_core() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseSELECT();
        if (s2 !== peg$FAILED) {
            s3 = peg$parseDISTINCT();
            if (s3 === peg$FAILED) {
                s3 = peg$parseALL();
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$currPos;
                s5 = peg$parseselect_result();
                if (s5 !== peg$FAILED) {
                    s6 = peg$currPos;
                    s7 = [];
                    s8 = peg$currPos;
                    s9 = peg$parsewhitespace();
                    if (s9 !== peg$FAILED) {
                        s10 = peg$parsecomma();
                        if (s10 !== peg$FAILED) {
                            s11 = peg$parseselect_result();
                            if (s11 !== peg$FAILED) {
                                s9 = [s9, s10, s11];
                                s8 = s9;
                            }
                            else {
                                peg$currPos = s8;
                                s8 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s8;
                            s8 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s8;
                        s8 = peg$FAILED;
                    }
                    while (s8 !== peg$FAILED) {
                        s7.push(s8);
                        s8 = peg$currPos;
                        s9 = peg$parsewhitespace();
                        if (s9 !== peg$FAILED) {
                            s10 = peg$parsecomma();
                            if (s10 !== peg$FAILED) {
                                s11 = peg$parseselect_result();
                                if (s11 !== peg$FAILED) {
                                    s9 = [s9, s10, s11];
                                    s8 = s9;
                                }
                                else {
                                    peg$currPos = s8;
                                    s8 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s8;
                                s8 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s8;
                            s8 = peg$FAILED;
                        }
                    }
                    if (s7 !== peg$FAILED) {
                        peg$savedPos = s6;
                        s7 = peg$c11(s3, s7);
                    }
                    s6 = s7;
                    if (s6 !== peg$FAILED) {
                        s5 = [s5, s6];
                        s4 = s5;
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$currPos;
                    s7 = peg$parseFROM();
                    if (s7 !== peg$FAILED) {
                        s8 = peg$parsejoin_source();
                        if (s8 !== peg$FAILED) {
                            s7 = [s7, s8];
                            s6 = s7;
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s6;
                        s6 = peg$FAILED;
                    }
                    if (s6 === peg$FAILED) {
                        s6 = null;
                    }
                    if (s6 !== peg$FAILED) {
                        peg$savedPos = s5;
                        s6 = peg$c12(s3, s4, s6);
                    }
                    s5 = s6;
                    if (s5 !== peg$FAILED) {
                        s6 = peg$currPos;
                        s7 = peg$currPos;
                        s8 = peg$parseWHERE();
                        if (s8 !== peg$FAILED) {
                            s9 = peg$parseexpr();
                            if (s9 !== peg$FAILED) {
                                s8 = [s8, s9];
                                s7 = s8;
                            }
                            else {
                                peg$currPos = s7;
                                s7 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s7;
                            s7 = peg$FAILED;
                        }
                        if (s7 === peg$FAILED) {
                            s7 = null;
                        }
                        if (s7 !== peg$FAILED) {
                            peg$savedPos = s6;
                            s7 = peg$c13(s3, s4, s5, s7);
                        }
                        s6 = s7;
                        if (s6 !== peg$FAILED) {
                            s7 = peg$currPos;
                            s8 = peg$parseGROUP();
                            if (s8 !== peg$FAILED) {
                                s9 = peg$parseBY();
                                if (s9 !== peg$FAILED) {
                                    s10 = [];
                                    s11 = peg$currPos;
                                    s12 = peg$parseordering_term();
                                    if (s12 !== peg$FAILED) {
                                        s13 = peg$parsecomma();
                                        if (s13 !== peg$FAILED) {
                                            s12 = [s12, s13];
                                            s11 = s12;
                                        }
                                        else {
                                            peg$currPos = s11;
                                            s11 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s11;
                                        s11 = peg$FAILED;
                                    }
                                    if (s11 !== peg$FAILED) {
                                        while (s11 !== peg$FAILED) {
                                            s10.push(s11);
                                            s11 = peg$currPos;
                                            s12 = peg$parseordering_term();
                                            if (s12 !== peg$FAILED) {
                                                s13 = peg$parsecomma();
                                                if (s13 !== peg$FAILED) {
                                                    s12 = [s12, s13];
                                                    s11 = s12;
                                                }
                                                else {
                                                    peg$currPos = s11;
                                                    s11 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s11;
                                                s11 = peg$FAILED;
                                            }
                                        }
                                    }
                                    else {
                                        s10 = peg$FAILED;
                                    }
                                    if (s10 !== peg$FAILED) {
                                        s11 = peg$currPos;
                                        s12 = peg$parseHAVING();
                                        if (s12 !== peg$FAILED) {
                                            s13 = peg$parseexpr();
                                            if (s13 !== peg$FAILED) {
                                                s12 = [s12, s13];
                                                s11 = s12;
                                            }
                                            else {
                                                peg$currPos = s11;
                                                s11 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s11;
                                            s11 = peg$FAILED;
                                        }
                                        if (s11 === peg$FAILED) {
                                            s11 = null;
                                        }
                                        if (s11 !== peg$FAILED) {
                                            s8 = [s8, s9, s10, s11];
                                            s7 = s8;
                                        }
                                        else {
                                            peg$currPos = s7;
                                            s7 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s7;
                                        s7 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s7;
                                    s7 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s7;
                                s7 = peg$FAILED;
                            }
                            if (s7 === peg$FAILED) {
                                s7 = null;
                            }
                            if (s7 !== peg$FAILED) {
                                s2 = [s2, s3, s4, s5, s6, s7];
                                s1 = s2;
                            }
                            else {
                                peg$currPos = s1;
                                s1 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s1;
                            s1 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c14();
        }
        s0 = s1;
        return s0;
    }
    function peg$parseselect_result() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parsewhitespace();
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$currPos;
            s5 = peg$parsecolumn_ref();
            if (s5 !== peg$FAILED) {
                s6 = peg$currPos;
                s7 = peg$currPos;
                s8 = peg$parseAS();
                if (s8 !== peg$FAILED) {
                    s9 = peg$parsewhitespace();
                    if (s9 !== peg$FAILED) {
                        s10 = peg$parsename();
                        if (s10 !== peg$FAILED) {
                            s8 = [s8, s9, s10];
                            s7 = s8;
                        }
                        else {
                            peg$currPos = s7;
                            s7 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s7;
                        s7 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s7;
                    s7 = peg$FAILED;
                }
                if (s7 !== peg$FAILED) {
                    peg$savedPos = s6;
                    s7 = peg$c15(s7);
                }
                s6 = s7;
                if (s6 === peg$FAILED) {
                    s6 = null;
                }
                if (s6 !== peg$FAILED) {
                    s5 = [s5, s6];
                    s4 = s5;
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s4;
                s4 = peg$FAILED;
            }
            if (s4 !== peg$FAILED) {
                peg$savedPos = s3;
                s4 = peg$c16(s4);
            }
            s3 = s4;
            if (s3 === peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$currPos;
                s5 = peg$parsename();
                if (s5 !== peg$FAILED) {
                    s6 = peg$parsedot();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parsestar();
                        if (s7 !== peg$FAILED) {
                            s5 = [s5, s6, s7];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
                if (s4 !== peg$FAILED) {
                    peg$savedPos = s3;
                    s4 = peg$c17(s4);
                }
                s3 = s4;
                if (s3 === peg$FAILED) {
                    s3 = peg$currPos;
                    s4 = peg$parsestar();
                    if (s4 !== peg$FAILED) {
                        peg$savedPos = s3;
                        s4 = peg$c18();
                    }
                    s3 = s4;
                }
            }
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c19(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsejoin_source() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parsewhitespace();
        if (s2 !== peg$FAILED) {
            s3 = peg$parsesingle_source();
            if (s3 !== peg$FAILED) {
                s4 = [];
                s5 = peg$currPos;
                s6 = peg$parsejoin_op();
                if (s6 !== peg$FAILED) {
                    s7 = peg$parsewhitespace();
                    if (s7 !== peg$FAILED) {
                        s8 = peg$parsesingle_source();
                        if (s8 !== peg$FAILED) {
                            s9 = peg$parsejoin_constraint();
                            if (s9 !== peg$FAILED) {
                                s6 = [s6, s7, s8, s9];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s5;
                    s5 = peg$FAILED;
                }
                while (s5 !== peg$FAILED) {
                    s4.push(s5);
                    s5 = peg$currPos;
                    s6 = peg$parsejoin_op();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parsewhitespace();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parsesingle_source();
                            if (s8 !== peg$FAILED) {
                                s9 = peg$parsejoin_constraint();
                                if (s9 !== peg$FAILED) {
                                    s6 = [s6, s7, s8, s9];
                                    s5 = s6;
                                }
                                else {
                                    peg$currPos = s5;
                                    s5 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                }
                if (s4 !== peg$FAILED) {
                    s2 = [s2, s3, s4];
                    s1 = s2;
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c20(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsesingle_source() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parsename();
        if (s2 !== peg$FAILED) {
            s3 = peg$parsedot();
            if (s3 !== peg$FAILED) {
                s4 = peg$parsename();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseAS();
                    if (s5 !== peg$FAILED) {
                        s6 = peg$parsewhitespace1();
                        if (s6 !== peg$FAILED) {
                            s7 = peg$parsename();
                            if (s7 !== peg$FAILED) {
                                s2 = [s2, s3, s4, s5, s6, s7];
                                s1 = s2;
                            }
                            else {
                                peg$currPos = s1;
                                s1 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s1;
                            s1 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c21(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$currPos;
            s2 = peg$parsename();
            if (s2 !== peg$FAILED) {
                s3 = peg$parsedot();
                if (s3 !== peg$FAILED) {
                    s4 = peg$parsename();
                    if (s4 !== peg$FAILED) {
                        s2 = [s2, s3, s4];
                        s1 = s2;
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
            if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c22(s1);
            }
            s0 = s1;
            if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$currPos;
                s2 = peg$parsename();
                if (s2 !== peg$FAILED) {
                    s3 = peg$parseAS();
                    if (s3 !== peg$FAILED) {
                        s4 = peg$parsewhitespace1();
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parsename();
                            if (s5 !== peg$FAILED) {
                                s2 = [s2, s3, s4, s5];
                                s1 = s2;
                            }
                            else {
                                peg$currPos = s1;
                                s1 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s1;
                            s1 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
                if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c23(s1);
                }
                s0 = s1;
                if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = peg$parsename();
                    if (s1 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c24(s1);
                    }
                    s0 = s1;
                    if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        s1 = peg$currPos;
                        s2 = peg$currPos;
                        s3 = peg$currPos;
                        s4 = peg$parsetable_ref();
                        if (s4 !== peg$FAILED) {
                            s5 = peg$currPos;
                            s6 = peg$currPos;
                            s7 = peg$parseAS();
                            if (s7 !== peg$FAILED) {
                                s8 = peg$parsewhitespace1();
                                if (s8 !== peg$FAILED) {
                                    s9 = peg$parsename();
                                    if (s9 !== peg$FAILED) {
                                        s7 = [s7, s8, s9];
                                        s6 = s7;
                                    }
                                    else {
                                        peg$currPos = s6;
                                        s6 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                            if (s6 !== peg$FAILED) {
                                peg$savedPos = s5;
                                s6 = peg$c15(s6);
                            }
                            s5 = s6;
                            if (s5 === peg$FAILED) {
                                s5 = null;
                            }
                            if (s5 !== peg$FAILED) {
                                s4 = [s4, s5];
                                s3 = s4;
                            }
                            else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                        if (s3 !== peg$FAILED) {
                            peg$savedPos = s2;
                            s3 = peg$c25(s3);
                        }
                        s2 = s3;
                        if (s2 !== peg$FAILED) {
                            s3 = peg$currPos;
                            s4 = peg$currPos;
                            s5 = peg$parseINDEXED();
                            if (s5 !== peg$FAILED) {
                                s6 = peg$parseBY();
                                if (s6 !== peg$FAILED) {
                                    s7 = peg$parsewhitespace();
                                    if (s7 !== peg$FAILED) {
                                        s8 = peg$parsename();
                                        if (s8 !== peg$FAILED) {
                                            s5 = [s5, s6, s7, s8];
                                            s4 = s5;
                                        }
                                        else {
                                            peg$currPos = s4;
                                            s4 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s4;
                                        s4 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s4;
                                    s4 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s4;
                                s4 = peg$FAILED;
                            }
                            if (s4 !== peg$FAILED) {
                                peg$savedPos = s3;
                                s4 = peg$c26(s4);
                            }
                            s3 = s4;
                            if (s3 === peg$FAILED) {
                                s3 = peg$currPos;
                                s4 = peg$currPos;
                                s5 = peg$parseNOT();
                                if (s5 !== peg$FAILED) {
                                    s6 = peg$parseINDEXED();
                                    if (s6 !== peg$FAILED) {
                                        s5 = [s5, s6];
                                        s4 = s5;
                                    }
                                    else {
                                        peg$currPos = s4;
                                        s4 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s4;
                                    s4 = peg$FAILED;
                                }
                                if (s4 !== peg$FAILED) {
                                    peg$savedPos = s3;
                                    s4 = peg$c27();
                                }
                                s3 = s4;
                            }
                            if (s3 === peg$FAILED) {
                                s3 = null;
                            }
                            if (s3 !== peg$FAILED) {
                                s2 = [s2, s3];
                                s1 = s2;
                            }
                            else {
                                peg$currPos = s1;
                                s1 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s1;
                            s1 = peg$FAILED;
                        }
                        if (s1 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c28(s1);
                        }
                        s0 = s1;
                        if (s0 === peg$FAILED) {
                            s0 = peg$currPos;
                            s1 = peg$currPos;
                            s2 = peg$parselparen();
                            if (s2 !== peg$FAILED) {
                                s3 = peg$parseselect_stmt();
                                if (s3 !== peg$FAILED) {
                                    s4 = peg$parserparen();
                                    if (s4 !== peg$FAILED) {
                                        s5 = peg$currPos;
                                        s6 = peg$currPos;
                                        s7 = peg$parseAS();
                                        if (s7 !== peg$FAILED) {
                                            s8 = peg$parsewhitespace();
                                            if (s8 !== peg$FAILED) {
                                                s9 = peg$parsename();
                                                if (s9 !== peg$FAILED) {
                                                    s7 = [s7, s8, s9];
                                                    s6 = s7;
                                                }
                                                else {
                                                    peg$currPos = s6;
                                                    s6 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s6;
                                                s6 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s6;
                                            s6 = peg$FAILED;
                                        }
                                        if (s6 !== peg$FAILED) {
                                            peg$savedPos = s5;
                                            s6 = peg$c15(s6);
                                        }
                                        s5 = s6;
                                        if (s5 === peg$FAILED) {
                                            s5 = null;
                                        }
                                        if (s5 !== peg$FAILED) {
                                            s2 = [s2, s3, s4, s5];
                                            s1 = s2;
                                        }
                                        else {
                                            peg$currPos = s1;
                                            s1 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s1;
                                        s1 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s1;
                                    s1 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s1;
                                s1 = peg$FAILED;
                            }
                            if (s1 !== peg$FAILED) {
                                peg$savedPos = s0;
                                s1 = peg$c29(s1);
                            }
                            s0 = s1;
                            if (s0 === peg$FAILED) {
                                s0 = peg$currPos;
                                s1 = peg$currPos;
                                s2 = peg$parselparen();
                                if (s2 !== peg$FAILED) {
                                    s3 = peg$parsejoin_source();
                                    if (s3 !== peg$FAILED) {
                                        s4 = peg$parserparen();
                                        if (s4 !== peg$FAILED) {
                                            s2 = [s2, s3, s4];
                                            s1 = s2;
                                        }
                                        else {
                                            peg$currPos = s1;
                                            s1 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s1;
                                        s1 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s1;
                                    s1 = peg$FAILED;
                                }
                                if (s1 !== peg$FAILED) {
                                    peg$savedPos = s0;
                                    s1 = peg$c30(s1);
                                }
                                s0 = s1;
                            }
                        }
                    }
                }
            }
        }
        return s0;
    }
    function peg$parsejoin_op() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$currPos;
        s3 = peg$parsewhitespace();
        if (s3 !== peg$FAILED) {
            s4 = peg$parsecomma();
            if (s4 !== peg$FAILED) {
                s3 = [s3, s4];
                s2 = s3;
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s2;
            s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
            peg$savedPos = s1;
            s2 = peg$c31();
        }
        s1 = s2;
        if (s1 === peg$FAILED) {
            s1 = peg$currPos;
            s2 = peg$currPos;
            s3 = peg$parseNATURAL();
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$currPos;
                s5 = peg$parseLEFT();
                if (s5 !== peg$FAILED) {
                    s6 = peg$parseOUTER();
                    if (s6 === peg$FAILED) {
                        s6 = null;
                    }
                    if (s6 !== peg$FAILED) {
                        s5 = [s5, s6];
                        s4 = s5;
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
                if (s4 === peg$FAILED) {
                    s4 = peg$parseINNER();
                    if (s4 === peg$FAILED) {
                        s4 = peg$parseCROSS();
                    }
                }
                if (s4 === peg$FAILED) {
                    s4 = null;
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseJOIN();
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                peg$savedPos = s1;
                s2 = peg$c32(s2);
            }
            s1 = s2;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c33(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsejoin_constraint() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseON();
        if (s2 !== peg$FAILED) {
            s3 = peg$parseexpr();
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 === peg$FAILED) {
            s1 = peg$currPos;
            s2 = peg$parseUSING();
            if (s2 !== peg$FAILED) {
                s3 = peg$parsewhitespace();
                if (s3 !== peg$FAILED) {
                    s4 = peg$parselparen();
                    if (s4 !== peg$FAILED) {
                        s5 = peg$currPos;
                        s6 = peg$parsewhitespace();
                        if (s6 !== peg$FAILED) {
                            s7 = peg$parsename();
                            if (s7 !== peg$FAILED) {
                                s8 = [];
                                s9 = peg$currPos;
                                s10 = peg$parsewhitespace();
                                if (s10 !== peg$FAILED) {
                                    s11 = peg$parsecomma();
                                    if (s11 !== peg$FAILED) {
                                        s12 = peg$parsewhitespace();
                                        if (s12 !== peg$FAILED) {
                                            s13 = peg$parsename();
                                            if (s13 !== peg$FAILED) {
                                                s10 = [s10, s11, s12, s13];
                                                s9 = s10;
                                            }
                                            else {
                                                peg$currPos = s9;
                                                s9 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s9;
                                            s9 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s9;
                                        s9 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s9;
                                    s9 = peg$FAILED;
                                }
                                while (s9 !== peg$FAILED) {
                                    s8.push(s9);
                                    s9 = peg$currPos;
                                    s10 = peg$parsewhitespace();
                                    if (s10 !== peg$FAILED) {
                                        s11 = peg$parsecomma();
                                        if (s11 !== peg$FAILED) {
                                            s12 = peg$parsewhitespace();
                                            if (s12 !== peg$FAILED) {
                                                s13 = peg$parsename();
                                                if (s13 !== peg$FAILED) {
                                                    s10 = [s10, s11, s12, s13];
                                                    s9 = s10;
                                                }
                                                else {
                                                    peg$currPos = s9;
                                                    s9 = peg$FAILED;
                                                }
                                            }
                                            else {
                                                peg$currPos = s9;
                                                s9 = peg$FAILED;
                                            }
                                        }
                                        else {
                                            peg$currPos = s9;
                                            s9 = peg$FAILED;
                                        }
                                    }
                                    else {
                                        peg$currPos = s9;
                                        s9 = peg$FAILED;
                                    }
                                }
                                if (s8 !== peg$FAILED) {
                                    s6 = [s6, s7, s8];
                                    s5 = s6;
                                }
                                else {
                                    peg$currPos = s5;
                                    s5 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                        if (s5 !== peg$FAILED) {
                            s6 = peg$parsewhitespace();
                            if (s6 !== peg$FAILED) {
                                s7 = peg$parserparen();
                                if (s7 !== peg$FAILED) {
                                    s2 = [s2, s3, s4, s5, s6, s7];
                                    s1 = s2;
                                }
                                else {
                                    peg$currPos = s1;
                                    s1 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s1;
                                s1 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s1;
                            s1 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        if (s1 === peg$FAILED) {
            s1 = null;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c34(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseordering_term() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace();
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parseexpr();
            if (s3 !== peg$FAILED) {
                s4 = peg$currPos;
                s5 = peg$parseCOLLATE();
                if (s5 !== peg$FAILED) {
                    s6 = peg$parsename();
                    if (s6 !== peg$FAILED) {
                        s5 = [s5, s6];
                        s4 = s5;
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
                if (s4 === peg$FAILED) {
                    s4 = null;
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseASC();
                    if (s5 === peg$FAILED) {
                        s5 = peg$parseDESC();
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsecompound_operator() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseUNION();
        if (s2 !== peg$FAILED) {
            s3 = peg$parseALL();
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 === peg$FAILED) {
            s1 = peg$parseINTERSECT();
            if (s1 === peg$FAILED) {
                s1 = peg$parseEXCEPT();
            }
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c35(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parseupdate_stmt() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseUPDATE();
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$parseOR();
            if (s4 !== peg$FAILED) {
                s5 = peg$parseROLLBACK();
                if (s5 === peg$FAILED) {
                    s5 = peg$parseABORT();
                    if (s5 === peg$FAILED) {
                        s5 = peg$parseREPLACE();
                        if (s5 === peg$FAILED) {
                            s5 = peg$parseFAIL();
                            if (s5 === peg$FAILED) {
                                s5 = peg$parseIGNORE();
                            }
                        }
                    }
                }
                if (s5 !== peg$FAILED) {
                    s4 = [s4, s5];
                    s3 = s4;
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parsequalified_table_name();
                if (s4 !== peg$FAILED) {
                    s2 = [s2, s3, s4];
                    s1 = s2;
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parseSET();
            if (s3 !== peg$FAILED) {
                s4 = [];
                s5 = peg$currPos;
                s6 = peg$currPos;
                s7 = peg$parsename();
                if (s7 !== peg$FAILED) {
                    s8 = peg$parseequal();
                    if (s8 !== peg$FAILED) {
                        s9 = peg$parseexpr();
                        if (s9 !== peg$FAILED) {
                            s7 = [s7, s8, s9];
                            s6 = s7;
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s6;
                        s6 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s6;
                    s6 = peg$FAILED;
                }
                if (s6 !== peg$FAILED) {
                    s7 = peg$parsecomma();
                    if (s7 !== peg$FAILED) {
                        s6 = [s6, s7];
                        s5 = s6;
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s5;
                    s5 = peg$FAILED;
                }
                if (s5 !== peg$FAILED) {
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$currPos;
                        s6 = peg$currPos;
                        s7 = peg$parsename();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseequal();
                            if (s8 !== peg$FAILED) {
                                s9 = peg$parseexpr();
                                if (s9 !== peg$FAILED) {
                                    s7 = [s7, s8, s9];
                                    s6 = s7;
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                        if (s6 !== peg$FAILED) {
                            s7 = peg$parsecomma();
                            if (s7 !== peg$FAILED) {
                                s6 = [s6, s7];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                }
                else {
                    s4 = peg$FAILED;
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$parseWHERE();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parseexpr();
                        if (s7 !== peg$FAILED) {
                            s6 = [s6, s7];
                            s5 = s6;
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseupdate_stmt_limited() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseUPDATE();
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$parseOR();
            if (s4 !== peg$FAILED) {
                s5 = peg$parseROLLBACK();
                if (s5 === peg$FAILED) {
                    s5 = peg$parseABORT();
                    if (s5 === peg$FAILED) {
                        s5 = peg$parseREPLACE();
                        if (s5 === peg$FAILED) {
                            s5 = peg$parseFAIL();
                            if (s5 === peg$FAILED) {
                                s5 = peg$parseIGNORE();
                            }
                        }
                    }
                }
                if (s5 !== peg$FAILED) {
                    s4 = [s4, s5];
                    s3 = s4;
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
                s3 = null;
            }
            if (s3 !== peg$FAILED) {
                s4 = peg$parsequalified_table_name();
                if (s4 !== peg$FAILED) {
                    s2 = [s2, s3, s4];
                    s1 = s2;
                }
                else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parseSET();
            if (s3 !== peg$FAILED) {
                s4 = [];
                s5 = peg$currPos;
                s6 = peg$currPos;
                s7 = peg$parsename();
                if (s7 !== peg$FAILED) {
                    s8 = peg$parseequal();
                    if (s8 !== peg$FAILED) {
                        s9 = peg$parseexpr();
                        if (s9 !== peg$FAILED) {
                            s7 = [s7, s8, s9];
                            s6 = s7;
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s6;
                        s6 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s6;
                    s6 = peg$FAILED;
                }
                if (s6 !== peg$FAILED) {
                    s7 = peg$parsecomma();
                    if (s7 !== peg$FAILED) {
                        s6 = [s6, s7];
                        s5 = s6;
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s5;
                    s5 = peg$FAILED;
                }
                if (s5 !== peg$FAILED) {
                    while (s5 !== peg$FAILED) {
                        s4.push(s5);
                        s5 = peg$currPos;
                        s6 = peg$currPos;
                        s7 = peg$parsename();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$parseequal();
                            if (s8 !== peg$FAILED) {
                                s9 = peg$parseexpr();
                                if (s9 !== peg$FAILED) {
                                    s7 = [s7, s8, s9];
                                    s6 = s7;
                                }
                                else {
                                    peg$currPos = s6;
                                    s6 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s6;
                                s6 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s6;
                            s6 = peg$FAILED;
                        }
                        if (s6 !== peg$FAILED) {
                            s7 = peg$parsecomma();
                            if (s7 !== peg$FAILED) {
                                s6 = [s6, s7];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                }
                else {
                    s4 = peg$FAILED;
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$parseWHERE();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parseexpr();
                        if (s7 !== peg$FAILED) {
                            s6 = [s6, s7];
                            s5 = s6;
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 === peg$FAILED) {
                        s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                s4 = peg$currPos;
                s5 = peg$parseORDER();
                if (s5 !== peg$FAILED) {
                    s6 = peg$parseBY();
                    if (s6 !== peg$FAILED) {
                        s7 = [];
                        s8 = peg$currPos;
                        s9 = peg$parseordering_term();
                        if (s9 !== peg$FAILED) {
                            s10 = peg$parsecomma();
                            if (s10 !== peg$FAILED) {
                                s9 = [s9, s10];
                                s8 = s9;
                            }
                            else {
                                peg$currPos = s8;
                                s8 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s8;
                            s8 = peg$FAILED;
                        }
                        if (s8 !== peg$FAILED) {
                            while (s8 !== peg$FAILED) {
                                s7.push(s8);
                                s8 = peg$currPos;
                                s9 = peg$parseordering_term();
                                if (s9 !== peg$FAILED) {
                                    s10 = peg$parsecomma();
                                    if (s10 !== peg$FAILED) {
                                        s9 = [s9, s10];
                                        s8 = s9;
                                    }
                                    else {
                                        peg$currPos = s8;
                                        s8 = peg$FAILED;
                                    }
                                }
                                else {
                                    peg$currPos = s8;
                                    s8 = peg$FAILED;
                                }
                            }
                        }
                        else {
                            s7 = peg$FAILED;
                        }
                        if (s7 !== peg$FAILED) {
                            s5 = [s5, s6, s7];
                            s4 = s5;
                        }
                        else {
                            peg$currPos = s4;
                            s4 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s4;
                        s4 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                }
                if (s4 === peg$FAILED) {
                    s4 = null;
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$currPos;
                    s6 = peg$parseLIMIT();
                    if (s6 !== peg$FAILED) {
                        s7 = peg$parseexpr();
                        if (s7 !== peg$FAILED) {
                            s8 = peg$currPos;
                            s9 = peg$parseOFFSET();
                            if (s9 === peg$FAILED) {
                                s9 = peg$parsecomma();
                            }
                            if (s9 !== peg$FAILED) {
                                s10 = peg$parseexpr();
                                if (s10 !== peg$FAILED) {
                                    s9 = [s9, s10];
                                    s8 = s9;
                                }
                                else {
                                    peg$currPos = s8;
                                    s8 = peg$FAILED;
                                }
                            }
                            else {
                                peg$currPos = s8;
                                s8 = peg$FAILED;
                            }
                            if (s8 === peg$FAILED) {
                                s8 = null;
                            }
                            if (s8 !== peg$FAILED) {
                                s6 = [s6, s7, s8];
                                s5 = s6;
                            }
                            else {
                                peg$currPos = s5;
                                s5 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s5;
                            s5 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s5;
                        s5 = peg$FAILED;
                    }
                    if (s5 !== peg$FAILED) {
                        s4 = [s4, s5];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                    s3 = null;
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsequalified_table_name() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parsetable_ref();
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parseINDEXED();
            if (s3 !== peg$FAILED) {
                s4 = peg$parseBY();
                if (s4 !== peg$FAILED) {
                    s5 = peg$parsename();
                    if (s5 !== peg$FAILED) {
                        s3 = [s3, s4, s5];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s2;
                s2 = peg$FAILED;
            }
            if (s2 === peg$FAILED) {
                s2 = peg$currPos;
                s3 = peg$parseNOT();
                if (s3 !== peg$FAILED) {
                    s4 = peg$parseINDEXED();
                    if (s4 !== peg$FAILED) {
                        s3 = [s3, s4];
                        s2 = s3;
                    }
                    else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                }
            }
            if (s2 === peg$FAILED) {
                s2 = null;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsetable_ref() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$currPos;
        s3 = peg$currPos;
        s4 = peg$parsename();
        if (s4 !== peg$FAILED) {
            s5 = peg$parsedot();
            if (s5 !== peg$FAILED) {
                s4 = [s4, s5];
                s3 = s4;
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s3;
            s3 = peg$FAILED;
        }
        if (s3 !== peg$FAILED) {
            peg$savedPos = s2;
            s3 = peg$c36(s3);
        }
        s2 = s3;
        if (s2 === peg$FAILED) {
            s2 = null;
        }
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$parsename();
            if (s4 !== peg$FAILED) {
                peg$savedPos = s3;
                s4 = peg$c24(s4);
            }
            s3 = s4;
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c37(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsecolumn_ref() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$currPos;
        s3 = peg$currPos;
        s4 = peg$parsename();
        if (s4 !== peg$FAILED) {
            s5 = peg$parsedot();
            if (s5 !== peg$FAILED) {
                s4 = [s4, s5];
                s3 = s4;
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s3;
            s3 = peg$FAILED;
        }
        if (s3 !== peg$FAILED) {
            peg$savedPos = s2;
            s3 = peg$c38(s3);
        }
        s2 = s3;
        if (s2 === peg$FAILED) {
            s2 = null;
        }
        if (s2 !== peg$FAILED) {
            s3 = peg$currPos;
            s4 = peg$parsename();
            if (s4 !== peg$FAILED) {
                peg$savedPos = s3;
                s4 = peg$c39(s4);
            }
            s3 = s4;
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c37(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsecomment_syntax() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = peg$parseminusminus();
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$currPos;
            if (peg$c40.test(input.charAt(peg$currPos))) {
                s4 = input.charAt(peg$currPos);
                peg$currPos++;
            }
            else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c41);
                }
            }
            if (s4 !== peg$FAILED) {
                s5 = peg$parseanything_except_newline();
                if (s5 !== peg$FAILED) {
                    s4 = [s4, s5];
                    s3 = s4;
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s3;
                s3 = peg$FAILED;
            }
            if (s3 !== peg$FAILED) {
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$currPos;
                    if (peg$c40.test(input.charAt(peg$currPos))) {
                        s4 = input.charAt(peg$currPos);
                        peg$currPos++;
                    }
                    else {
                        s4 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c41);
                        }
                    }
                    if (s4 !== peg$FAILED) {
                        s5 = peg$parseanything_except_newline();
                        if (s5 !== peg$FAILED) {
                            s4 = [s4, s5];
                            s3 = s4;
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$parsenewline();
                if (s3 === peg$FAILED) {
                    s3 = peg$parseend_of_input();
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parsecomment_beg();
            if (s1 !== peg$FAILED) {
                s2 = [];
                s3 = peg$currPos;
                if (peg$c40.test(input.charAt(peg$currPos))) {
                    s4 = input.charAt(peg$currPos);
                    peg$currPos++;
                }
                else {
                    s4 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c41);
                    }
                }
                if (s4 !== peg$FAILED) {
                    s5 = peg$parseanything_except_comment_end();
                    if (s5 !== peg$FAILED) {
                        s4 = [s4, s5];
                        s3 = s4;
                    }
                    else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                }
                if (s3 !== peg$FAILED) {
                    while (s3 !== peg$FAILED) {
                        s2.push(s3);
                        s3 = peg$currPos;
                        if (peg$c40.test(input.charAt(peg$currPos))) {
                            s4 = input.charAt(peg$currPos);
                            peg$currPos++;
                        }
                        else {
                            s4 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c41);
                            }
                        }
                        if (s4 !== peg$FAILED) {
                            s5 = peg$parseanything_except_comment_end();
                            if (s5 !== peg$FAILED) {
                                s4 = [s4, s5];
                                s3 = s4;
                            }
                            else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                            }
                        }
                        else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                        }
                    }
                }
                else {
                    s2 = peg$FAILED;
                }
                if (s2 !== peg$FAILED) {
                    s3 = peg$parsecomment_end();
                    if (s3 === peg$FAILED) {
                        s3 = peg$parseend_of_input();
                    }
                    if (s3 !== peg$FAILED) {
                        s1 = [s1, s2, s3];
                        s0 = s1;
                    }
                    else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                    }
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        return s0;
    }
    function peg$parsedot() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 46) {
            s0 = peg$c42;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c43);
            }
        }
        return s0;
    }
    function peg$parsecomma() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 44) {
            s0 = peg$c44;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c45);
            }
        }
        return s0;
    }
    function peg$parsesemicolon() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 59) {
            s0 = peg$c46;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c47);
            }
        }
        return s0;
    }
    function peg$parseminusminus() {
        var s0;
        if (input.substr(peg$currPos, 2) === peg$c48) {
            s0 = peg$c48;
            peg$currPos += 2;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c49);
            }
        }
        return s0;
    }
    function peg$parseminus() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 45) {
            s0 = peg$c50;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c51);
            }
        }
        return s0;
    }
    function peg$parseplus() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 43) {
            s0 = peg$c52;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c53);
            }
        }
        return s0;
    }
    function peg$parselparen() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 40) {
            s0 = peg$c54;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c55);
            }
        }
        return s0;
    }
    function peg$parserparen() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 41) {
            s0 = peg$c56;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c57);
            }
        }
        return s0;
    }
    function peg$parsestar() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 42) {
            s0 = peg$c58;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c59);
            }
        }
        return s0;
    }
    function peg$parsenewline() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 10) {
            s0 = peg$c60;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c61);
            }
        }
        return s0;
    }
    function peg$parseanything_except_newline() {
        var s0, s1;
        s0 = [];
        if (peg$c40.test(input.charAt(peg$currPos))) {
            s1 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c41);
            }
        }
        while (s1 !== peg$FAILED) {
            s0.push(s1);
            if (peg$c40.test(input.charAt(peg$currPos))) {
                s1 = input.charAt(peg$currPos);
                peg$currPos++;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c41);
                }
            }
        }
        return s0;
    }
    function peg$parsecomment_beg() {
        var s0;
        if (input.substr(peg$currPos, 2) === peg$c62) {
            s0 = peg$c62;
            peg$currPos += 2;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c63);
            }
        }
        return s0;
    }
    function peg$parsecomment_end() {
        var s0;
        if (input.substr(peg$currPos, 2) === peg$c64) {
            s0 = peg$c64;
            peg$currPos += 2;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c65);
            }
        }
        return s0;
    }
    function peg$parseanything_except_comment_end() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = [];
        if (input.length > peg$currPos) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c66);
            }
        }
        while (s2 !== peg$FAILED) {
            s1.push(s2);
            if (input.length > peg$currPos) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c66);
                }
            }
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            peg$silentFails++;
            if (input.substr(peg$currPos, 2) === peg$c64) {
                s3 = peg$c64;
                peg$currPos += 2;
            }
            else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c65);
                }
            }
            peg$silentFails--;
            if (s3 !== peg$FAILED) {
                peg$currPos = s2;
                s2 = void 0;
            }
            else {
                s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsestring_literal() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 34) {
            s1 = peg$c67;
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c68);
            }
        }
        if (s1 !== peg$FAILED) {
            s2 = [];
            s3 = peg$parseescape_char();
            if (s3 === peg$FAILED) {
                if (peg$c69.test(input.charAt(peg$currPos))) {
                    s3 = input.charAt(peg$currPos);
                    peg$currPos++;
                }
                else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c70);
                    }
                }
            }
            while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parseescape_char();
                if (s3 === peg$FAILED) {
                    if (peg$c69.test(input.charAt(peg$currPos))) {
                        s3 = input.charAt(peg$currPos);
                        peg$currPos++;
                    }
                    else {
                        s3 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c70);
                        }
                    }
                }
            }
            if (s2 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 34) {
                    s3 = peg$c67;
                    peg$currPos++;
                }
                else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c68);
                    }
                }
                if (s3 !== peg$FAILED) {
                    s1 = [s1, s2, s3];
                    s0 = s1;
                }
                else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                }
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseescape_char() {
        var s0, s1, s2;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 92) {
            s1 = peg$c71;
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c72);
            }
        }
        if (s1 !== peg$FAILED) {
            if (input.length > peg$currPos) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c66);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsenil() {
        var s0;
        s0 = peg$c73;
        return s0;
    }
    function peg$parsewhitespace() {
        var s0, s1;
        s0 = [];
        if (peg$c74.test(input.charAt(peg$currPos))) {
            s1 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c75);
            }
        }
        while (s1 !== peg$FAILED) {
            s0.push(s1);
            if (peg$c74.test(input.charAt(peg$currPos))) {
                s1 = input.charAt(peg$currPos);
                peg$currPos++;
            }
            else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c75);
                }
            }
        }
        return s0;
    }
    function peg$parsewhitespace1() {
        var s0, s1;
        s0 = [];
        if (peg$c74.test(input.charAt(peg$currPos))) {
            s1 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c75);
            }
        }
        if (s1 !== peg$FAILED) {
            while (s1 !== peg$FAILED) {
                s0.push(s1);
                if (peg$c74.test(input.charAt(peg$currPos))) {
                    s1 = input.charAt(peg$currPos);
                    peg$currPos++;
                }
                else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c75);
                    }
                }
            }
        }
        else {
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseunary_operator() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parsewhitespace();
        if (s2 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 45) {
                s3 = peg$c50;
                peg$currPos++;
            }
            else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c51);
                }
            }
            if (s3 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 43) {
                    s3 = peg$c52;
                    peg$currPos++;
                }
                else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c53);
                    }
                }
                if (s3 === peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 126) {
                        s3 = peg$c76;
                        peg$currPos++;
                    }
                    else {
                        s3 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c77);
                        }
                    }
                    if (s3 === peg$FAILED) {
                        if (input.substr(peg$currPos, 3) === peg$c78) {
                            s3 = peg$c78;
                            peg$currPos += 3;
                        }
                        else {
                            s3 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c79);
                            }
                        }
                    }
                }
            }
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c80(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsebinary_operator() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parsewhitespace();
        if (s2 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c81) {
                s3 = peg$c81;
                peg$currPos += 2;
            }
            else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c82);
                }
            }
            if (s3 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 42) {
                    s3 = peg$c58;
                    peg$currPos++;
                }
                else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c59);
                    }
                }
                if (s3 === peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 47) {
                        s3 = peg$c83;
                        peg$currPos++;
                    }
                    else {
                        s3 = peg$FAILED;
                        if (peg$silentFails === 0) {
                            peg$fail(peg$c84);
                        }
                    }
                    if (s3 === peg$FAILED) {
                        if (input.charCodeAt(peg$currPos) === 37) {
                            s3 = peg$c85;
                            peg$currPos++;
                        }
                        else {
                            s3 = peg$FAILED;
                            if (peg$silentFails === 0) {
                                peg$fail(peg$c86);
                            }
                        }
                        if (s3 === peg$FAILED) {
                            if (input.charCodeAt(peg$currPos) === 43) {
                                s3 = peg$c52;
                                peg$currPos++;
                            }
                            else {
                                s3 = peg$FAILED;
                                if (peg$silentFails === 0) {
                                    peg$fail(peg$c53);
                                }
                            }
                            if (s3 === peg$FAILED) {
                                if (input.charCodeAt(peg$currPos) === 45) {
                                    s3 = peg$c50;
                                    peg$currPos++;
                                }
                                else {
                                    s3 = peg$FAILED;
                                    if (peg$silentFails === 0) {
                                        peg$fail(peg$c51);
                                    }
                                }
                                if (s3 === peg$FAILED) {
                                    if (input.substr(peg$currPos, 2) === peg$c87) {
                                        s3 = peg$c87;
                                        peg$currPos += 2;
                                    }
                                    else {
                                        s3 = peg$FAILED;
                                        if (peg$silentFails === 0) {
                                            peg$fail(peg$c88);
                                        }
                                    }
                                    if (s3 === peg$FAILED) {
                                        if (input.substr(peg$currPos, 2) === peg$c89) {
                                            s3 = peg$c89;
                                            peg$currPos += 2;
                                        }
                                        else {
                                            s3 = peg$FAILED;
                                            if (peg$silentFails === 0) {
                                                peg$fail(peg$c90);
                                            }
                                        }
                                        if (s3 === peg$FAILED) {
                                            if (input.charCodeAt(peg$currPos) === 38) {
                                                s3 = peg$c91;
                                                peg$currPos++;
                                            }
                                            else {
                                                s3 = peg$FAILED;
                                                if (peg$silentFails === 0) {
                                                    peg$fail(peg$c92);
                                                }
                                            }
                                            if (s3 === peg$FAILED) {
                                                if (input.charCodeAt(peg$currPos) === 124) {
                                                    s3 = peg$c93;
                                                    peg$currPos++;
                                                }
                                                else {
                                                    s3 = peg$FAILED;
                                                    if (peg$silentFails === 0) {
                                                        peg$fail(peg$c94);
                                                    }
                                                }
                                                if (s3 === peg$FAILED) {
                                                    if (input.substr(peg$currPos, 2) === peg$c95) {
                                                        s3 = peg$c95;
                                                        peg$currPos += 2;
                                                    }
                                                    else {
                                                        s3 = peg$FAILED;
                                                        if (peg$silentFails === 0) {
                                                            peg$fail(peg$c96);
                                                        }
                                                    }
                                                    if (s3 === peg$FAILED) {
                                                        if (input.substr(peg$currPos, 2) === peg$c97) {
                                                            s3 = peg$c97;
                                                            peg$currPos += 2;
                                                        }
                                                        else {
                                                            s3 = peg$FAILED;
                                                            if (peg$silentFails === 0) {
                                                                peg$fail(peg$c98);
                                                            }
                                                        }
                                                        if (s3 === peg$FAILED) {
                                                            if (input.charCodeAt(peg$currPos) === 60) {
                                                                s3 = peg$c99;
                                                                peg$currPos++;
                                                            }
                                                            else {
                                                                s3 = peg$FAILED;
                                                                if (peg$silentFails === 0) {
                                                                    peg$fail(peg$c100);
                                                                }
                                                            }
                                                            if (s3 === peg$FAILED) {
                                                                if (input.charCodeAt(peg$currPos) === 62) {
                                                                    s3 = peg$c101;
                                                                    peg$currPos++;
                                                                }
                                                                else {
                                                                    s3 = peg$FAILED;
                                                                    if (peg$silentFails === 0) {
                                                                        peg$fail(peg$c102);
                                                                    }
                                                                }
                                                                if (s3 === peg$FAILED) {
                                                                    if (input.charCodeAt(peg$currPos) === 61) {
                                                                        s3 = peg$c103;
                                                                        peg$currPos++;
                                                                    }
                                                                    else {
                                                                        s3 = peg$FAILED;
                                                                        if (peg$silentFails === 0) {
                                                                            peg$fail(peg$c104);
                                                                        }
                                                                    }
                                                                    if (s3 === peg$FAILED) {
                                                                        if (input.substr(peg$currPos, 2) === peg$c105) {
                                                                            s3 = peg$c105;
                                                                            peg$currPos += 2;
                                                                        }
                                                                        else {
                                                                            s3 = peg$FAILED;
                                                                            if (peg$silentFails === 0) {
                                                                                peg$fail(peg$c106);
                                                                            }
                                                                        }
                                                                        if (s3 === peg$FAILED) {
                                                                            if (input.substr(peg$currPos, 2) === peg$c107) {
                                                                                s3 = peg$c107;
                                                                                peg$currPos += 2;
                                                                            }
                                                                            else {
                                                                                s3 = peg$FAILED;
                                                                                if (peg$silentFails === 0) {
                                                                                    peg$fail(peg$c108);
                                                                                }
                                                                            }
                                                                            if (s3 === peg$FAILED) {
                                                                                if (input.substr(peg$currPos, 2) === peg$c109) {
                                                                                    s3 = peg$c109;
                                                                                    peg$currPos += 2;
                                                                                }
                                                                                else {
                                                                                    s3 = peg$FAILED;
                                                                                    if (peg$silentFails === 0) {
                                                                                        peg$fail(peg$c110);
                                                                                    }
                                                                                }
                                                                                if (s3 === peg$FAILED) {
                                                                                    if (input.substr(peg$currPos, 2) === peg$c111) {
                                                                                        s3 = peg$c111;
                                                                                        peg$currPos += 2;
                                                                                    }
                                                                                    else {
                                                                                        s3 = peg$FAILED;
                                                                                        if (peg$silentFails === 0) {
                                                                                            peg$fail(peg$c112);
                                                                                        }
                                                                                    }
                                                                                    if (s3 === peg$FAILED) {
                                                                                        if (input.substr(peg$currPos, 6) === peg$c113) {
                                                                                            s3 = peg$c113;
                                                                                            peg$currPos += 6;
                                                                                        }
                                                                                        else {
                                                                                            s3 = peg$FAILED;
                                                                                            if (peg$silentFails === 0) {
                                                                                                peg$fail(peg$c114);
                                                                                            }
                                                                                        }
                                                                                        if (s3 === peg$FAILED) {
                                                                                            if (input.substr(peg$currPos, 2) === peg$c115) {
                                                                                                s3 = peg$c115;
                                                                                                peg$currPos += 2;
                                                                                            }
                                                                                            else {
                                                                                                s3 = peg$FAILED;
                                                                                                if (peg$silentFails === 0) {
                                                                                                    peg$fail(peg$c116);
                                                                                                }
                                                                                            }
                                                                                            if (s3 === peg$FAILED) {
                                                                                                if (input.substr(peg$currPos, 4) === peg$c117) {
                                                                                                    s3 = peg$c117;
                                                                                                    peg$currPos += 4;
                                                                                                }
                                                                                                else {
                                                                                                    s3 = peg$FAILED;
                                                                                                    if (peg$silentFails === 0) {
                                                                                                        peg$fail(peg$c118);
                                                                                                    }
                                                                                                }
                                                                                                if (s3 === peg$FAILED) {
                                                                                                    if (input.substr(peg$currPos, 4) === peg$c119) {
                                                                                                        s3 = peg$c119;
                                                                                                        peg$currPos += 4;
                                                                                                    }
                                                                                                    else {
                                                                                                        s3 = peg$FAILED;
                                                                                                        if (peg$silentFails === 0) {
                                                                                                            peg$fail(peg$c120);
                                                                                                        }
                                                                                                    }
                                                                                                    if (s3 === peg$FAILED) {
                                                                                                        if (input.substr(peg$currPos, 5) === peg$c121) {
                                                                                                            s3 = peg$c121;
                                                                                                            peg$currPos += 5;
                                                                                                        }
                                                                                                        else {
                                                                                                            s3 = peg$FAILED;
                                                                                                            if (peg$silentFails === 0) {
                                                                                                                peg$fail(peg$c122);
                                                                                                            }
                                                                                                        }
                                                                                                        if (s3 === peg$FAILED) {
                                                                                                            if (input.substr(peg$currPos, 6) === peg$c123) {
                                                                                                                s3 = peg$c123;
                                                                                                                peg$currPos += 6;
                                                                                                            }
                                                                                                            else {
                                                                                                                s3 = peg$FAILED;
                                                                                                                if (peg$silentFails === 0) {
                                                                                                                    peg$fail(peg$c124);
                                                                                                                }
                                                                                                            }
                                                                                                            if (s3 === peg$FAILED) {
                                                                                                                if (input.substr(peg$currPos, 3) === peg$c125) {
                                                                                                                    s3 = peg$c125;
                                                                                                                    peg$currPos += 3;
                                                                                                                }
                                                                                                                else {
                                                                                                                    s3 = peg$FAILED;
                                                                                                                    if (peg$silentFails === 0) {
                                                                                                                        peg$fail(peg$c126);
                                                                                                                    }
                                                                                                                }
                                                                                                                if (s3 === peg$FAILED) {
                                                                                                                    if (input.substr(peg$currPos, 2) === peg$c127) {
                                                                                                                        s3 = peg$c127;
                                                                                                                        peg$currPos += 2;
                                                                                                                    }
                                                                                                                    else {
                                                                                                                        s3 = peg$FAILED;
                                                                                                                        if (peg$silentFails === 0) {
                                                                                                                            peg$fail(peg$c128);
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if (s3 !== peg$FAILED) {
                s2 = [s2, s3];
                s1 = s2;
            }
            else {
                peg$currPos = s1;
                s1 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s1;
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c80(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsedigit() {
        var s0;
        if (peg$c129.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c130);
            }
        }
        return s0;
    }
    function peg$parseequal() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 61) {
            s0 = peg$c103;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c104);
            }
        }
        return s0;
    }
    function peg$parsename() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        if (peg$c131.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
        }
        else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c132);
            }
        }
        if (s2 !== peg$FAILED) {
            while (s2 !== peg$FAILED) {
                s1.push(s2);
                if (peg$c131.test(input.charAt(peg$currPos))) {
                    s2 = input.charAt(peg$currPos);
                    peg$currPos++;
                }
                else {
                    s2 = peg$FAILED;
                    if (peg$silentFails === 0) {
                        peg$fail(peg$c132);
                    }
                }
            }
        }
        else {
            s1 = peg$FAILED;
        }
        if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c133(s1);
        }
        s0 = s1;
        return s0;
    }
    function peg$parsebind_parameter() {
        var s0, s1, s2;
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 63) {
            s1 = peg$c134;
            peg$currPos++;
        }
        else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c135);
            }
        }
        if (s1 !== peg$FAILED) {
            s2 = peg$parsename();
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCURRENT_TIME() {
        var s0;
        if (input.substr(peg$currPos, 3) === peg$c136) {
            s0 = peg$c136;
            peg$currPos += 3;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c137);
            }
        }
        return s0;
    }
    function peg$parseCURRENT_DATE() {
        var s0;
        if (input.substr(peg$currPos, 3) === peg$c136) {
            s0 = peg$c136;
            peg$currPos += 3;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c137);
            }
        }
        return s0;
    }
    function peg$parseCURRENT_TIMESTAMP() {
        var s0;
        if (input.substr(peg$currPos, 3) === peg$c136) {
            s0 = peg$c136;
            peg$currPos += 3;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c137);
            }
        }
        return s0;
    }
    function peg$parseend_of_input() {
        var s0;
        s0 = peg$c73;
        return s0;
    }
    function peg$parseABORT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c138) {
                s2 = peg$c138;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c139);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseACTION() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c140) {
                s2 = peg$c140;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c141);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseADD() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c142) {
                s2 = peg$c142;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c143);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseAFTER() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c144) {
                s2 = peg$c144;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c145);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseALL() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c146) {
                s2 = peg$c146;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c147);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseALTER() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c148) {
                s2 = peg$c148;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c149);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseANALYZE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c150) {
                s2 = peg$c150;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c151);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseAND() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c125) {
                s2 = peg$c125;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c126);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseAS() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c152) {
                s2 = peg$c152;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c153);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseASC() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c154) {
                s2 = peg$c154;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c155);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseATTACH() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c156) {
                s2 = peg$c156;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c157);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseAUTOINCREMENT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 13) === peg$c158) {
                s2 = peg$c158;
                peg$currPos += 13;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c159);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseBEFORE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c160) {
                s2 = peg$c160;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c161);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseBEGIN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c162) {
                s2 = peg$c162;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c163);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseBETWEEN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c164) {
                s2 = peg$c164;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c165);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseBY() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c166) {
                s2 = peg$c166;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c167);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCASCADE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c168) {
                s2 = peg$c168;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c169);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCASE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c170) {
                s2 = peg$c170;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c171);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCAST() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c172) {
                s2 = peg$c172;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c173);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCHECK() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c174) {
                s2 = peg$c174;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c175);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCOLLATE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c176) {
                s2 = peg$c176;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c177);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCOLUMN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c178) {
                s2 = peg$c178;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c179);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCOMMIT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c180) {
                s2 = peg$c180;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c181);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCONFLICT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 8) === peg$c182) {
                s2 = peg$c182;
                peg$currPos += 8;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c183);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCONSTRAINT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 10) === peg$c184) {
                s2 = peg$c184;
                peg$currPos += 10;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c185);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCREATE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c186) {
                s2 = peg$c186;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c187);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseCROSS() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c188) {
                s2 = peg$c188;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c189);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseDATABASE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 8) === peg$c190) {
                s2 = peg$c190;
                peg$currPos += 8;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c191);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseDEFAULT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c192) {
                s2 = peg$c192;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c193);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseDEFERRABLE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 10) === peg$c194) {
                s2 = peg$c194;
                peg$currPos += 10;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c195);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseDEFERRED() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 8) === peg$c196) {
                s2 = peg$c196;
                peg$currPos += 8;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c197);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseDELETE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c198) {
                s2 = peg$c198;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c199);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseDESC() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c200) {
                s2 = peg$c200;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c201);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseDETACH() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c202) {
                s2 = peg$c202;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c203);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseDISTINCT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 8) === peg$c204) {
                s2 = peg$c204;
                peg$currPos += 8;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c205);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseDROP() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c206) {
                s2 = peg$c206;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c207);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseE() {
        var s0;
        if (input.charCodeAt(peg$currPos) === 69) {
            s0 = peg$c208;
            peg$currPos++;
        }
        else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
                peg$fail(peg$c209);
            }
        }
        return s0;
    }
    function peg$parseEACH() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c210) {
                s2 = peg$c210;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c211);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseELSE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c212) {
                s2 = peg$c212;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c213);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseEND() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c214) {
                s2 = peg$c214;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c215);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseESCAPE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c216) {
                s2 = peg$c216;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c217);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseEXCEPT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c218) {
                s2 = peg$c218;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c219);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseEXCLUSIVE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 9) === peg$c220) {
                s2 = peg$c220;
                peg$currPos += 9;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c221);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseEXISTS() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c222) {
                s2 = peg$c222;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c223);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseEXPLAIN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c224) {
                s2 = peg$c224;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c225);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseFAIL() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c226) {
                s2 = peg$c226;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c227);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseFOR() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c228) {
                s2 = peg$c228;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c229);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseFOREIGN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c230) {
                s2 = peg$c230;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c231);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseFROM() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c232) {
                s2 = peg$c232;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c233);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseGLOB() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c119) {
                s2 = peg$c119;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c120);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseGROUP() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c234) {
                s2 = peg$c234;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c235);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseHAVING() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c236) {
                s2 = peg$c236;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c237);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseIF() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c238) {
                s2 = peg$c238;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c239);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseIGNORE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c240) {
                s2 = peg$c240;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c241);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseIMMEDIATE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 9) === peg$c242) {
                s2 = peg$c242;
                peg$currPos += 9;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c243);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseIN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c115) {
                s2 = peg$c115;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c116);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseINDEX() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c244) {
                s2 = peg$c244;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c245);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseINDEXED() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c246) {
                s2 = peg$c246;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c247);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseINITIALLY() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 9) === peg$c248) {
                s2 = peg$c248;
                peg$currPos += 9;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c249);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseINNER() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c250) {
                s2 = peg$c250;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c251);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseINSERT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c252) {
                s2 = peg$c252;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c253);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseINSTEAD() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c254) {
                s2 = peg$c254;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c255);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseINTERSECT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 9) === peg$c256) {
                s2 = peg$c256;
                peg$currPos += 9;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c257);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseINTO() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c258) {
                s2 = peg$c258;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c259);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseIS() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c111) {
                s2 = peg$c111;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c112);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseISNULL() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c260) {
                s2 = peg$c260;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c261);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseJOIN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c262) {
                s2 = peg$c262;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c263);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseKEY() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c264) {
                s2 = peg$c264;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c265);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseLEFT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c266) {
                s2 = peg$c266;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c267);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseLIKE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c117) {
                s2 = peg$c117;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c118);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseLIMIT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c268) {
                s2 = peg$c268;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c269);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseMATCH() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c121) {
                s2 = peg$c121;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c122);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseNATURAL() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c270) {
                s2 = peg$c270;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c271);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseNO() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c272) {
                s2 = peg$c272;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c273);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseNOT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c78) {
                s2 = peg$c78;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c79);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseNOTNULL() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c274) {
                s2 = peg$c274;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c275);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseNULL() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c276) {
                s2 = peg$c276;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c277);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseOF() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c278) {
                s2 = peg$c278;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c279);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseOFFSET() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c280) {
                s2 = peg$c280;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c281);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseON() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c282) {
                s2 = peg$c282;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c283);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseOR() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c127) {
                s2 = peg$c127;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c128);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseORDER() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c284) {
                s2 = peg$c284;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c285);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseOUTER() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c286) {
                s2 = peg$c286;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c287);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsePLAN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c288) {
                s2 = peg$c288;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c289);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsePRAGMA() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c290) {
                s2 = peg$c290;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c291);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parsePRIMARY() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c292) {
                s2 = peg$c292;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c293);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseQUERY() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c294) {
                s2 = peg$c294;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c295);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseRAISE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c296) {
                s2 = peg$c296;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c297);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseREFERENCES() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 10) === peg$c298) {
                s2 = peg$c298;
                peg$currPos += 10;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c299);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseREGEXP() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c123) {
                s2 = peg$c123;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c124);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseREINDEX() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c300) {
                s2 = peg$c300;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c301);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseRELEASE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c302) {
                s2 = peg$c302;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c303);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseRENAME() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c304) {
                s2 = peg$c304;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c305);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseREPLACE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c306) {
                s2 = peg$c306;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c307);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseRESTRICT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 8) === peg$c308) {
                s2 = peg$c308;
                peg$currPos += 8;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c309);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseROLLBACK() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 8) === peg$c310) {
                s2 = peg$c310;
                peg$currPos += 8;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c311);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseROW() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c312) {
                s2 = peg$c312;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c313);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseSAVEPOINT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 9) === peg$c314) {
                s2 = peg$c314;
                peg$currPos += 9;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c315);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseSELECT() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c316) {
                s2 = peg$c316;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c317);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseSET() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c318) {
                s2 = peg$c318;
                peg$currPos += 3;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c319);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseTABLE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c320) {
                s2 = peg$c320;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c321);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseTEMP() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c322) {
                s2 = peg$c322;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c323);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseTEMPORARY() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 9) === peg$c324) {
                s2 = peg$c324;
                peg$currPos += 9;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c325);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseTHEN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c326) {
                s2 = peg$c326;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c327);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseTO() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c328) {
                s2 = peg$c328;
                peg$currPos += 2;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c329);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseTRANSACTION() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 11) === peg$c330) {
                s2 = peg$c330;
                peg$currPos += 11;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c331);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseTRIGGER() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c332) {
                s2 = peg$c332;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c333);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseUNION() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c334) {
                s2 = peg$c334;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c335);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseUNIQUE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c336) {
                s2 = peg$c336;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c337);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseUPDATE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c338) {
                s2 = peg$c338;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c339);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseUSING() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c340) {
                s2 = peg$c340;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c341);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseVACUUM() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c342) {
                s2 = peg$c342;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c343);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseVALUES() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c344) {
                s2 = peg$c344;
                peg$currPos += 6;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c345);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseVIEW() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c346) {
                s2 = peg$c346;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c347);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseVIRTUAL() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c348) {
                s2 = peg$c348;
                peg$currPos += 7;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c349);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseWHEN() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c350) {
                s2 = peg$c350;
                peg$currPos += 4;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c351);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    function peg$parseWHERE() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = peg$parsewhitespace1();
        if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 5) === peg$c352) {
                s2 = peg$c352;
                peg$currPos += 5;
            }
            else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) {
                    peg$fail(peg$c353);
                }
            }
            if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
            }
            else {
                peg$currPos = s0;
                s0 = peg$FAILED;
            }
        }
        else {
            peg$currPos = s0;
            s0 = peg$FAILED;
        }
        return s0;
    }
    peg$result = peg$startRuleFunction();
    if (peg$result !== peg$FAILED && peg$currPos === input.length) {
        return peg$result;
    }
    else {
        if (peg$result !== peg$FAILED && peg$currPos < input.length) {
            peg$fail(peg$endExpectation());
        }
        throw peg$buildStructuredError(peg$maxFailExpected, peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null, peg$maxFailPos < input.length
            ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1)
            : peg$computeLocation(peg$maxFailPos, peg$maxFailPos));
    }
}
module.exports = {
    SyntaxError: peg$SyntaxError,
    parse: peg$parse
};
//# sourceMappingURL=sql.js.map